
/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else /* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif /* __STDC__ */
#endif /* ! __cplusplus */

#ifdef __TURBOC__
#pragma warn -rch
#pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
{
  FILE *yy_input_file;

  char *yy_ch_buf;		/* input buffer */
  char *yy_buf_pos;		/* current position in input buffer */

  /* Size of input buffer in bytes, not including room for EOB
   * characters.
   */
  yy_size_t yy_buf_size;

  /* Number of characters read into yy_ch_buf, not including EOB
   * characters.
   */
  int yy_n_chars;

  /* Whether we "own" the buffer - i.e., we know we created it,
   * and can realloc() it to grow it, and should free() it to
   * delete it.
   */
  int yy_is_our_buffer;

  /* Whether this is an "interactive" input source; if so, and
   * if we're using stdio for input, then we want to use getc()
   * instead of fread(), to make sure we stop fetching input after
   * each newline.
   */
  int yy_is_interactive;

  /* Whether we're considered to be at the beginning of a line.
   * If so, '^' rules will be active on the next match, otherwise
   * not.
   */
  int yy_at_bol;

  /* Whether to try to fill the input buffer when we reach the
   * end of it.
   */
  int yy_fill_buffer;

  int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
  /* When an EOF's been seen but there's still some text to process
   * then we mark the buffer as YY_EOF_PENDING, to indicate that we
   * shouldn't try reading from the input source any more.  We might
   * still have a bunch of tokens to match, though, because of
   * possible backing-up.
   *
   * When we actually see the EOF, we change the status to "new"
   * (via yyrestart()), so that the user can continue scanning by
   * just pointing yyin at a new input file.
   */
#define YY_BUFFER_EOF_PENDING 2
};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO ((FILE * input_file));

void yy_switch_to_buffer YY_PROTO ((YY_BUFFER_STATE new_buffer));
void yy_load_buffer_state YY_PROTO ((void));
YY_BUFFER_STATE yy_create_buffer YY_PROTO ((FILE * file, int size));
void yy_delete_buffer YY_PROTO ((YY_BUFFER_STATE b));
void yy_init_buffer YY_PROTO ((YY_BUFFER_STATE b, FILE * file));
void yy_flush_buffer YY_PROTO ((YY_BUFFER_STATE b));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO ((char *base, yy_size_t size));
YY_BUFFER_STATE yy_scan_string YY_PROTO ((yyconst char *yy_str));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO ((yyconst char *bytes, int len));

static void *yy_flex_alloc YY_PROTO ((yy_size_t));
static void *yy_flex_realloc YY_PROTO ((void *, yy_size_t));
static void yy_flex_free YY_PROTO ((void *));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT

#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO ((void));
static yy_state_type yy_try_NUL_trans
YY_PROTO ((yy_state_type current_state));
static int yy_get_next_buffer YY_PROTO ((void));
static void yy_fatal_error YY_PROTO ((yyconst char msg[]));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yytext_ptr -= yy_more_len; \
	yyleng = (int) (yy_cp - yytext_ptr); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 208
#define YY_END_OF_BUFFER 209
static yyconst short int yy_acclist[889] = { 0,
  16386, 4, 4, 209, 207, 208, 1, 207, 208, 7,
  208, 196, 207, 208, 207, 208, 197, 207, 208, 197,
  207, 208, 197, 199, 207, 208, 197, 207, 208, 198,
  199, 207, 208, 8, 197, 207, 208, 194, 207, 208,
  193, 207, 208, 195, 207, 208, 79, 207, 208, 174,
  207, 208, 188, 207, 208, 204, 207, 208, 204, 207,
  208, 204, 207, 208, 204, 207, 208, 204, 207, 208,
  204, 207, 208, 204, 207, 208, 204, 207, 208, 204,
  207, 208, 204, 207, 208, 204, 207, 208, 204, 207,
  208, 204, 207, 208, 204, 207, 208, 204, 207, 208,

  204, 207, 208, 204, 207, 208, 204, 207, 208, 204,
  207, 208, 204, 207, 208, 204, 207, 208, 204, 207,
  208, 1, 207, 208, 16386, 207, 208, 207, 208, 8194,
  198, 199, 207, 208, 208, 3, 208, 4, 208, 5,
  208, 208, 15, 208, 1, 6, 206, 206, 189, 199,
  10, 199, 198, 199, 191, 190, 192, 205, 204, 204,
  204, 204, 204, 42, 204, 173, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 204, 204, 204,
  204, 40, 204, 204, 204, 204, 204, 204, 204, 204,
  67, 204, 204, 204, 204, 204, 204, 204, 61, 204,

  204, 204, 204, 204, 204, 204, 204, 204, 204, 204,
  204, 204, 204, 57, 204, 204, 90, 204, 204, 204,
  200, 204, 204, 204, 204, 204, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 204, 204, 204,
  204, 204, 204, 204, 41, 204, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 1, 16386, 8194,
  17, 18, 8194, 198, 199, 3, 4, 14, 199, 10,
  204, 141, 204, 204, 89, 204, 204, 169, 204, 204,
  204, 204, 204, 204, 204, 204, 108, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 131, 204, 204,

  204, 172, 204, 204, 82, 204, 16, 204, 97, 204,
  204, 84, 204, 159, 204, 92, 204, 204, 204, 204,
  204, 135, 204, 204, 204, 34, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 139, 204, 204,
  204, 157, 204, 123, 204, 204, 204, 136, 204, 204,
  204, 204, 146, 204, 204, 145, 204, 143, 204, 204,
  117, 204, 204, 91, 204, 204, 204, 204, 204, 204,
  204, 204, 204, 144, 204, 204, 204, 204, 12, 204,
  204, 204, 204, 204, 204, 204, 204, 204, 204, 204,
  142, 204, 129, 204, 204, 204, 138, 204, 204, 204,

  204, 53, 204, 204, 204, 133, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 204, 204, 158, 204, 204,
  204, 204, 204, 204, 93, 204, 14, 204, 132, 204,
  204, 130, 204, 134, 204, 204, 122, 204, 121, 204,
  171, 205, 128, 204, 204, 204, 37, 204, 168, 205,
  204, 204, 204, 204, 204, 204, 204, 87, 204, 204,
  204, 16, 16, 204, 63, 204, 204, 204, 204, 204,
  204, 85, 204, 204, 204, 103, 204, 140, 204, 204,
  204, 187, 204, 204, 51, 204, 170, 205, 204, 204,
  204, 204, 204, 204, 204, 98, 204, 204, 39, 204,

  204, 204, 149, 205, 204, 46, 204, 204, 68, 204,
  204, 204, 180, 204, 182, 204, 204, 204, 204, 86,
  204, 107, 204, 204, 9, 11, 204, 204, 204, 204,
  204, 204, 204, 204, 204, 70, 204, 204, 204, 137,
  204, 204, 45, 204, 160, 205, 204, 204, 204, 71,
  204, 105, 204, 62, 204, 204, 204, 204, 204, 202,
  204, 204, 204, 204, 118, 204, 48, 204, 204, 204,
  204, 14, 204, 204, 204, 35, 204, 204, 102, 204,
  69, 204, 75, 204, 204, 204, 204, 99, 204, 178,
  205, 204, 16, 16, 204, 204, 64, 204, 66, 204,

  33, 204, 201, 204, 204, 204, 203, 204, 204, 204,
  204, 52, 204, 204, 204, 80, 204, 155, 204, 204,
  60, 204, 147, 205, 55, 204, 204, 204, 204, 204,
  204, 119, 204, 181, 205, 72, 204, 204, 204, 204,
  204, 83, 204, 9, 9, 204, 204, 204, 204, 204,
  204, 204, 204, 204, 120, 204, 185, 204, 204, 204,
  204, 204, 179, 205, 183, 204, 204, 154, 205, 50,
  204, 204, 73, 204, 47, 204, 204, 204, 14, 204,
  204, 204, 204, 110, 204, 100, 204, 76, 204, 204,
  204, 204, 204, 65, 204, 24, 25, 204, 32, 204,

  104, 204, 204, 204, 13, 204, 161, 205, 204, 150,
  205, 152, 205, 164, 204, 204, 162, 204, 163, 204,
  204, 95, 204, 204, 111, 204, 204, 204, 204, 49,
  204, 204, 81, 204, 204, 148, 205, 156, 204, 153,
  205, 204, 175, 204, 186, 205, 56, 204, 204, 36,
  204, 177, 204, 184, 205, 204, 151, 205, 94, 204,
  204, 204, 204, 204, 109, 204, 112, 205, 21, 204,
  204, 38, 204, 204, 23, 19, 204, 114, 205, 204,
  204, 204, 204, 204, 96, 204, 204, 43, 204, 204,
  88, 204, 74, 204, 204, 204, 176, 205, 204, 44,

  204, 124, 204, 204, 204, 113, 205, 59, 204, 204,
  20, 205, 204, 204, 204, 166, 204, 127, 204, 204,
  204, 204, 204, 101, 204, 204, 126, 204, 77, 204,
  204, 204, 26, 27, 204, 58, 204, 204, 204, 127,
  204, 115, 204, 106, 204, 204, 204, 204, 78, 204,
  204, 28, 29, 116, 205, 204, 204, 127, 204, 54,
  204, 204, 204, 30, 31, 165, 204, 204, 204, 204,
  204, 204, 204, 204, 16, 204, 167, 204, 204, 125,
  204, 204, 204, 204, 204, 204, 22, 204
};

static yyconst short int yy_accept[669] = { 0,
  1, 1, 2, 2, 2, 3, 4, 4, 4, 4,
  4, 5, 7, 10, 12, 15, 17, 20, 23, 27,
  30, 34, 38, 41, 44, 47, 50, 53, 56, 59,
  62, 65, 68, 71, 74, 77, 80, 83, 86, 89,
  92, 95, 98, 101, 104, 107, 110, 113, 116, 119,
  122, 126, 128, 130, 135, 136, 138, 140, 142, 143,
  145, 146, 147, 147, 148, 149, 150, 151, 151, 152,
  153, 155, 156, 157, 158, 159, 159, 160, 161, 162,
  163, 164, 166, 168, 169, 170, 171, 172, 173, 174,
  175, 176, 177, 178, 179, 180, 181, 182, 184, 185,

  186, 187, 188, 189, 190, 191, 193, 194, 195, 196,
  197, 198, 199, 201, 202, 203, 204, 205, 206, 207,
  208, 209, 210, 211, 212, 213, 214, 216, 217, 219,
  220, 221, 223, 224, 225, 226, 227, 228, 229, 230,
  231, 232, 233, 234, 235, 236, 237, 238, 239, 240,
  241, 242, 243, 244, 245, 247, 248, 249, 250, 251,
  252, 253, 254, 255, 256, 257, 258, 260, 261, 261,
  262, 262, 263, 266, 267, 268, 268, 269, 269, 270,
  271, 272, 274, 275, 277, 278, 280, 281, 282, 283,
  284, 285, 286, 287, 289, 290, 291, 292, 293, 294,

  295, 296, 297, 298, 300, 301, 302, 304, 305, 307,
  309, 311, 312, 314, 316, 318, 319, 320, 321, 322,
  324, 325, 326, 328, 329, 330, 331, 332, 333, 334,
  335, 336, 337, 338, 340, 341, 342, 344, 346, 347,
  348, 350, 351, 352, 353, 355, 356, 358, 360, 361,
  363, 364, 366, 367, 368, 369, 370, 371, 372, 373,
  374, 376, 377, 378, 379, 381, 382, 383, 384, 385,
  386, 387, 388, 389, 390, 391, 393, 395, 396, 397,
  399, 400, 401, 402, 404, 405, 406, 408, 409, 410,
  411, 412, 413, 414, 415, 416, 417, 418, 420, 421,

  422, 423, 424, 425, 427, 427, 428, 429, 431, 432,
  434, 436, 437, 439, 441, 443, 445, 446, 447, 449,
  451, 452, 453, 454, 455, 456, 457, 458, 460, 461,
  462, 463, 465, 467, 468, 468, 468, 469, 470, 471,
  472, 474, 475, 476, 478, 480, 481, 482, 484, 485,
  487, 489, 490, 491, 492, 493, 494, 495, 496, 498,
  499, 501, 502, 503, 505, 506, 508, 509, 511, 512,
  513, 515, 517, 518, 519, 520, 522, 524, 525, 526,
  527, 528, 529, 530, 531, 532, 533, 534, 535, 536,
  538, 539, 540, 542, 543, 545, 547, 548, 549, 550,

  552, 554, 556, 557, 558, 559, 560, 562, 563, 564,
  565, 567, 569, 570, 571, 572, 573, 574, 575, 576,
  578, 579, 581, 583, 585, 586, 587, 588, 590, 592,
  593, 594, 595, 596, 597, 599, 599, 599, 599, 599,
  599, 599, 601, 603, 605, 606, 607, 609, 610, 611,
  612, 614, 615, 616, 618, 620, 621, 623, 625, 627,
  628, 629, 630, 631, 632, 634, 636, 638, 639, 640,
  641, 642, 644, 645, 646, 647, 648, 649, 650, 651,
  652, 653, 654, 655, 657, 659, 660, 661, 662, 663,
  665, 667, 668, 670, 672, 673, 675, 677, 678, 679,

  680, 681, 682, 683, 684, 686, 688, 690, 691, 692,
  693, 694, 696, 697, 697, 697, 697, 698, 698, 698,
  699, 701, 703, 704, 705, 707, 709, 710, 712, 714,
  716, 717, 719, 721, 722, 724, 725, 727, 728, 729,
  730, 732, 733, 735, 736, 738, 740, 742, 743, 745,
  747, 749, 750, 752, 754, 756, 757, 759, 761, 762,
  763, 764, 765, 767, 769, 771, 772, 774, 775, 776,
  776, 776, 776, 776, 778, 780, 781, 782, 783, 784,
  785, 787, 788, 790, 791, 793, 795, 796, 797, 799,
  800, 802, 804, 805, 806, 808, 810, 811, 811, 811,

  811, 811, 813, 814, 815, 816, 818, 820, 821, 822,
  823, 824, 826, 827, 829, 831, 832, 833, 833, 834,
  834, 835, 836, 838, 839, 840, 840, 840, 842, 844,
  846, 847, 848, 849, 851, 852, 853, 854, 856, 857,
  858, 858, 859, 860, 862, 863, 864, 865, 866, 868,
  869, 870, 871, 872, 873, 874, 875, 877, 879, 880,
  882, 883, 884, 885, 886, 887, 889, 889
};

static yyconst int yy_ec[256] = { 0,
  1, 1, 1, 1, 1, 1, 1, 1, 2, 3,
  2, 2, 2, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 2, 4, 5, 6, 7, 1, 1, 8, 9,
  10, 11, 12, 13, 14, 15, 16, 17, 17, 17,
  17, 17, 17, 17, 17, 17, 17, 18, 13, 19,
  20, 21, 22, 23, 26, 27, 28, 29, 30, 31,
  32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
  42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
  1, 1, 1, 24, 25, 1, 26, 27, 28, 29,

  30, 31, 32, 33, 34, 35, 36, 37, 38, 39,
  40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
  50, 51, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,

  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1
};

static yyconst int yy_meta[52] = { 0,
  1, 2, 3, 1, 1, 1, 4, 1, 1, 1,
  1, 1, 1, 1, 5, 1, 6, 1, 1, 1,
  1, 1, 1, 1, 7, 7, 7, 7, 7, 7,
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
  7
};

static yyconst short int yy_base[685] = { 0,
  0, 50, 516, 507, 515, 508, 491, 487, 0, 0,
  487, 1950, 475, 469, 1950, 50, 1950, 457, 40, 445,
  44, 1950, 42, 1950, 438, 1950, 1950, 1950, 53, 68,
  58, 107, 46, 147, 51, 90, 72, 93, 112, 130,
  119, 128, 142, 149, 171, 192, 122, 102, 194, 75,
  52, 443, 437, 89, 1950, 418, 0, 1950, 419, 1950,
  418, 1950, 61, 113, 1950, 1950, 93, 186, 0, 128,
  214, 1950, 1950, 1950, 1950, 0, 195, 199, 200, 223,
  226, 232, 235, 239, 238, 241, 242, 244, 248, 255,
  257, 264, 258, 269, 270, 275, 286, 292, 274, 298,

  301, 302, 304, 316, 314, 315, 318, 321, 319, 328,
  333, 347, 348, 351, 358, 352, 367, 365, 369, 368,
  374, 393, 378, 380, 398, 403, 412, 418, 419, 423,
  424, 429, 430, 440, 435, 442, 456, 444, 445, 456,
  455, 449, 484, 460, 471, 489, 495, 499, 500, 498,
  502, 512, 505, 515, 521, 522, 524, 533, 536, 539,
  537, 540, 543, 552, 558, 557, 76, 399, 412, 1950,
  411, 1950, 545, 374, 0, 388, 373, 369, 354, 0,
  363, 458, 571, 573, 575, 574, 578, 580, 587, 589,
  590, 591, 601, 592, 596, 603, 606, 617, 622, 619,

  624, 628, 629, 631, 634, 635, 640, 644, 645, 651,
  647, 660, 669, 665, 670, 671, 672, 681, 684, 685,
  686, 691, 697, 698, 700, 707, 701, 703, 716, 717,
  726, 730, 733, 731, 735, 744, 745, 747, 751, 748,
  757, 760, 762, 764, 773, 775, 776, 778, 779, 780,
  789, 790, 792, 793, 795, 796, 799, 806, 802, 811,
  805, 815, 809, 822, 843, 832, 836, 842, 845, 846,
  852, 856, 857, 859, 858, 861, 862, 863, 876, 877,
  880, 890, 891, 892, 893, 894, 896, 897, 906, 908,
  911, 912, 917, 922, 929, 938, 933, 913, 939, 942,

  943, 949, 952, 954, 0, 354, 353, 955, 958, 959,
  968, 970, 972, 974, 1950, 975, 979, 981, 984, 1950,
  985, 986, 988, 995, 997, 998, 1000, 999, 1004, 1013,
  354, 1019, 1018, 1020, 1021, 305, 1029, 1030, 1032, 1033,
  1035, 1039, 1046, 1051, 1049, 1055, 1056, 1065, 1070, 1071,
  1950, 1076, 1080, 1081, 1085, 1086, 1083, 1087, 1092, 1096,
  1097, 1098, 1099, 1950, 1101, 1102, 1108, 1103, 1117, 1120,
  1129, 1131, 1132, 1133, 1138, 1142, 1145, 1147, 340, 1950,
  1148, 1149, 1154, 1158, 1163, 1165, 1168, 1175, 1172, 1177,
  1179, 1181, 1184, 1188, 1197, 1950, 1198, 1200, 1204, 1209,

  1210, 1214, 1216, 1220, 1225, 1226, 1229, 1230, 1232, 1236,
  1235, 1239, 1241, 1242, 1245, 0, 1248, 1246, 1251, 1255,
  1258, 1265, 1269, 1274, 1276, 1280, 1283, 1286, 1950, 1287,
  0, 336, 1290, 1292, 1293, 283, 102, 277, 257, 239,
  250, 1296, 1297, 1299, 1303, 1306, 1318, 1320, 1319, 1322,
  1321, 1323, 1324, 1325, 1335, 1337, 1338, 1950, 1339, 1340,
  1351, 1352, 1354, 1355, 1356, 1950, 1366, 1367, 1368, 1369,
  1370, 1371, 0, 276, 1380, 1384, 1385, 1391, 1398, 1400,
  1403, 1407, 1413, 1414, 1416, 1419, 1423, 1425, 1426, 1950,
  1429, 1435, 1950, 1439, 1441, 1442, 1444, 1446, 1448, 0,

  1455, 1458, 1453, 1459, 1464, 1465, 1468, 1469, 1470, 1481,
  1471, 1486, 1950, 231, 202, 189, 1950, 177, 175, 1488,
  1490, 1491, 1493, 1500, 1502, 1950, 1504, 1950, 1950, 1505,
  1506, 1507, 1516, 1517, 1518, 1520, 1521, 1522, 1527, 1532,
  1533, 1538, 1534, 1547, 1950, 1550, 1950, 1551, 1554, 1950,
  1560, 1563, 1564, 1565, 1950, 1567, 1950, 1569, 1578, 1576,
  1579, 1580, 1581, 1950, 1582, 1583, 1585, 1592, 1950, 159,
  155, 146, 143, 1594, 1950, 1596, 1608, 1609, 1610, 1612,
  1614, 1621, 1625, 1626, 1627, 1628, 1631, 1637, 1950, 1638,
  1640, 1650, 1651, 1652, 1950, 1654, 1657, 150, 147, 123,

  109, 1950, 1655, 1667, 1669, 1670, 1684, 1672, 1685, 1681,
  1682, 1695, 1698, 1701, 1710, 1711, 1712, 103, 1950, 92,
  1950, 1715, 1716, 1725, 1727, 172, 1731, 1736, 1729, 1732,
  1741, 1745, 1746, 1748, 1752, 114, 96, 1950, 1755, 1757,
  1764, 1950, 1762, 1761, 1764, 1766, 1950, 1950, 1773, 1778,
  1788, 1782, 1789, 1792, 1794, 1795, 1798, 1804, 1808, 1805,
  1811, 1817, 1810, 1814, 1826, 1829, 1950, 1860, 1867, 1874,
  1881, 1885, 1892, 1899, 1906, 1912, 1919, 92, 1922, 1926,
  64, 1933, 1940, 1942
};

static yyconst short int yy_def[685] = { 0,
  667, 1, 668, 668, 669, 669, 668, 668, 670, 670,
  667, 667, 667, 667, 667, 671, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 672, 672,
  672, 672, 31, 672, 31, 672, 672, 672, 31, 31,
  672, 672, 31, 39, 44, 31, 672, 672, 31, 672,
  667, 673, 674, 667, 667, 667, 675, 667, 676, 667,
  667, 667, 671, 671, 667, 667, 667, 667, 677, 667,
  667, 667, 667, 667, 667, 678, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,

  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 115, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 667, 667, 673, 667,
  674, 667, 667, 667, 675, 676, 679, 667, 667, 677,
  680, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,

  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,

  672, 672, 672, 672, 681, 679, 680, 672, 672, 672,
  672, 672, 672, 672, 667, 672, 672, 672, 672, 667,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  682, 672, 672, 672, 667, 667, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  667, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 667, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 683, 667,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 667, 672, 672, 672, 672,

  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 684, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 667, 672,
  682, 682, 672, 672, 672, 667, 667, 667, 667, 667,
  667, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 667, 672, 672,
  672, 672, 672, 672, 672, 667, 672, 672, 672, 672,
  672, 672, 683, 683, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 667,
  672, 672, 667, 672, 672, 672, 672, 672, 672, 684,

  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 667, 667, 667, 667, 667, 667, 667, 672,
  672, 672, 672, 672, 672, 667, 672, 667, 667, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 667, 672, 667, 672, 672, 667,
  672, 672, 672, 672, 667, 672, 667, 672, 672, 672,
  672, 672, 672, 667, 672, 672, 672, 672, 667, 667,
  667, 667, 667, 672, 667, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 667, 672,
  672, 672, 672, 672, 667, 672, 672, 667, 667, 667,

  667, 667, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 667, 667, 667,
  667, 672, 672, 672, 672, 667, 667, 672, 672, 672,
  672, 672, 672, 672, 672, 667, 667, 667, 672, 672,
  667, 667, 672, 672, 672, 672, 667, 667, 672, 672,
  672, 672, 672, 672, 672, 672, 672, 672, 672, 672,
  672, 672, 672, 672, 672, 672, 0, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667
};

static yyconst short int yy_nxt[2002] = { 0,
  12, 13, 14, 15, 16, 12, 12, 12, 17, 17,
  18, 17, 17, 17, 19, 20, 21, 22, 23, 24,
  25, 26, 27, 28, 29, 30, 31, 32, 33, 34,
  35, 36, 37, 38, 29, 29, 39, 40, 41, 42,
  43, 29, 44, 45, 46, 47, 48, 49, 50, 29,
  29, 51, 64, 167, 65, 52, 67, 53, 70, 75,
  71, 72, 73, 64, 75, 65, 54, 76, 168, 68,
  416, 95, 76, 68, 75, 96, 105, 167, 75, 97,
  77, 75, 76, 84, 106, 98, 76, 85, 77, 76,
  107, 86, 168, 108, 78, 79, 75, 87, 181, 75,

  88, 112, 648, 70, 76, 173, 80, 76, 75, 67,
  81, 82, 83, 75, 166, 64, 76, 65, 68, 109,
  647, 76, 68, 113, 637, 75, 110, 160, 75, 111,
  114, 115, 89, 76, 75, 636, 76, 116, 621, 90,
  91, 117, 76, 92, 67, 118, 93, 514, 124, 515,
  620, 119, 94, 75, 77, 121, 120, 68, 125, 77,
  157, 76, 158, 122, 126, 159, 127, 130, 128, 123,
  129, 131, 77, 626, 136, 132, 619, 618, 137, 601,
  627, 133, 138, 99, 134, 100, 101, 135, 77, 102,
  600, 599, 103, 139, 140, 104, 77, 178, 141, 178,

  142, 75, 179, 598, 143, 75, 75, 144, 573, 76,
  572, 145, 146, 76, 76, 147, 148, 151, 149, 161,
  150, 152, 571, 162, 153, 154, 163, 164, 70, 75,
  71, 155, 75, 77, 156, 570, 165, 76, 75, 183,
  76, 75, 182, 68, 75, 75, 76, 75, 75, 76,
  75, 184, 76, 76, 75, 76, 76, 569, 76, 186,
  188, 75, 76, 75, 75, 187, 189, 190, 185, 76,
  75, 76, 76, 195, 191, 75, 75, 474, 76, 192,
  75, 75, 519, 76, 76, 193, 518, 517, 76, 76,
  194, 196, 75, 199, 201, 202, 203, 197, 75, 198,

  76, 204, 207, 200, 75, 208, 76, 75, 75, 516,
  75, 205, 76, 513, 206, 76, 76, 212, 76, 210,
  75, 75, 75, 209, 75, 75, 213, 75, 76, 76,
  76, 214, 76, 76, 75, 76, 211, 432, 439, 75,
  217, 474, 76, 215, 216, 218, 224, 76, 440, 219,
  221, 222, 441, 75, 75, 432, 220, 75, 75, 75,
  223, 76, 76, 225, 75, 76, 76, 226, 305, 75,
  179, 75, 76, 75, 75, 75, 227, 228, 235, 76,
  75, 76, 76, 76, 75, 179, 75, 305, 76, 176,
  174, 230, 76, 231, 76, 229, 240, 236, 232, 75,

  241, 233, 234, 239, 75, 237, 248, 76, 242, 75,
  244, 238, 76, 172, 170, 168, 243, 76, 75, 61,
  176, 246, 245, 249, 75, 75, 76, 250, 251, 75,
  75, 247, 76, 76, 174, 75, 75, 76, 76, 172,
  253, 75, 252, 76, 76, 170, 75, 254, 75, 76,
  75, 75, 255, 257, 76, 75, 76, 74, 76, 76,
  69, 75, 75, 76, 75, 258, 75, 66, 256, 76,
  76, 62, 76, 259, 76, 270, 61, 75, 275, 260,
  261, 262, 271, 263, 264, 76, 667, 272, 59, 278,
  75, 77, 59, 265, 273, 75, 266, 274, 76, 267,

  268, 75, 269, 76, 75, 75, 75, 279, 75, 76,
  58, 75, 76, 76, 76, 276, 76, 58, 75, 76,
  281, 75, 277, 56, 282, 284, 76, 75, 75, 76,
  75, 280, 56, 285, 290, 76, 76, 283, 76, 75,
  287, 286, 75, 75, 667, 75, 75, 76, 288, 75,
  76, 76, 291, 76, 76, 293, 292, 76, 75, 70,
  289, 173, 667, 75, 75, 667, 76, 294, 295, 297,
  299, 76, 76, 296, 68, 298, 301, 75, 300, 75,
  75, 75, 667, 667, 75, 76, 75, 76, 76, 76,
  302, 303, 76, 75, 76, 75, 75, 315, 75, 304,

  309, 76, 75, 76, 76, 76, 76, 75, 667, 75,
  76, 667, 320, 667, 308, 76, 310, 76, 311, 316,
  76, 318, 312, 75, 667, 75, 314, 317, 75, 313,
  75, 76, 319, 76, 75, 75, 76, 75, 76, 667,
  75, 75, 76, 76, 321, 76, 75, 322, 76, 76,
  75, 75, 331, 75, 76, 667, 667, 75, 76, 76,
  328, 76, 323, 324, 329, 76, 75, 667, 325, 330,
  335, 75, 667, 326, 76, 75, 75, 75, 75, 76,
  327, 667, 336, 76, 76, 76, 76, 75, 667, 333,
  75, 75, 75, 334, 667, 76, 332, 75, 76, 76,

  76, 339, 337, 75, 75, 76, 75, 75, 340, 75,
  338, 76, 76, 75, 76, 76, 667, 76, 667, 667,
  667, 76, 351, 75, 342, 345, 346, 344, 341, 343,
  76, 76, 75, 348, 667, 667, 75, 75, 667, 75,
  76, 75, 350, 347, 76, 76, 349, 76, 667, 76,
  75, 75, 667, 75, 75, 353, 352, 75, 76, 76,
  356, 76, 76, 75, 357, 76, 75, 667, 75, 667,
  75, 76, 667, 360, 76, 354, 76, 355, 76, 75,
  359, 364, 75, 667, 75, 75, 75, 76, 358, 76,
  76, 362, 76, 76, 76, 75, 75, 363, 75, 75,

  361, 75, 75, 76, 76, 75, 76, 76, 75, 76,
  76, 75, 75, 76, 667, 75, 76, 75, 667, 76,
  76, 75, 365, 76, 667, 76, 369, 667, 75, 76,
  667, 368, 367, 366, 371, 372, 76, 374, 75, 370,
  373, 667, 75, 376, 379, 380, 76, 667, 75, 75,
  76, 75, 75, 377, 375, 378, 76, 76, 75, 76,
  76, 381, 75, 75, 75, 75, 76, 75, 75, 75,
  76, 76, 76, 76, 384, 76, 76, 76, 385, 667,
  382, 667, 75, 75, 667, 667, 75, 383, 389, 387,
  76, 76, 391, 390, 76, 386, 75, 396, 75, 75,

  75, 388, 75, 75, 76, 76, 76, 76, 76, 392,
  76, 76, 75, 667, 75, 667, 667, 75, 75, 75,
  76, 393, 76, 75, 394, 76, 76, 76, 75, 667,
  395, 76, 667, 400, 397, 75, 76, 398, 399, 75,
  403, 404, 405, 76, 75, 75, 402, 76, 75, 75,
  401, 407, 76, 76, 406, 75, 76, 76, 75, 667,
  75, 75, 408, 76, 75, 75, 76, 409, 76, 76,
  412, 410, 76, 76, 75, 667, 75, 414, 75, 413,
  75, 75, 76, 411, 76, 75, 76, 75, 76, 76,
  75, 75, 75, 76, 75, 76, 415, 418, 76, 76,

  76, 75, 76, 75, 75, 75, 75, 417, 667, 76,
  429, 76, 76, 76, 76, 419, 420, 423, 76, 75,
  331, 421, 335, 667, 75, 75, 75, 76, 422, 428,
  426, 427, 76, 76, 76, 75, 75, 424, 75, 75,
  425, 75, 667, 76, 76, 75, 76, 76, 667, 76,
  435, 434, 75, 76, 436, 75, 433, 75, 430, 442,
  76, 75, 75, 76, 437, 76, 667, 667, 438, 76,
  76, 75, 443, 667, 444, 447, 75, 75, 445, 76,
  448, 446, 75, 450, 76, 76, 75, 75, 449, 75,
  76, 75, 75, 458, 76, 76, 451, 76, 75, 76,

  76, 76, 75, 75, 75, 75, 76, 75, 75, 75,
  76, 76, 76, 76, 75, 76, 76, 76, 452, 457,
  667, 667, 76, 75, 667, 454, 75, 455, 456, 453,
  462, 76, 459, 463, 76, 466, 461, 75, 75, 75,
  460, 667, 667, 76, 75, 76, 76, 76, 75, 465,
  464, 75, 76, 75, 75, 75, 76, 667, 667, 76,
  75, 76, 76, 76, 75, 469, 468, 667, 76, 75,
  471, 75, 76, 475, 75, 470, 467, 76, 75, 76,
  667, 75, 76, 75, 472, 75, 76, 75, 476, 76,
  75, 76, 667, 76, 75, 76, 477, 667, 76, 667,

  478, 483, 76, 75, 75, 481, 75, 479, 482, 480,
  75, 76, 76, 667, 76, 75, 75, 667, 76, 484,
  75, 486, 490, 76, 76, 485, 75, 488, 76, 667,
  76, 75, 493, 489, 76, 75, 75, 487, 75, 76,
  76, 75, 75, 76, 76, 75, 76, 75, 75, 76,
  76, 75, 75, 76, 75, 76, 76, 75, 491, 76,
  76, 75, 76, 492, 75, 76, 494, 496, 667, 76,
  497, 75, 76, 667, 495, 75, 501, 667, 499, 76,
  75, 498, 75, 76, 504, 503, 75, 506, 76, 75,
  76, 502, 75, 75, 76, 505, 75, 76, 75, 75,

  76, 76, 75, 75, 76, 75, 76, 76, 667, 75,
  76, 76, 75, 76, 667, 667, 508, 76, 507, 511,
  76, 509, 512, 510, 75, 75, 75, 75, 75, 75,
  526, 75, 76, 76, 76, 76, 76, 76, 76, 76,
  667, 75, 667, 75, 75, 75, 528, 520, 522, 76,
  521, 76, 76, 76, 76, 667, 667, 529, 75, 667,
  75, 75, 75, 523, 524, 76, 76, 525, 76, 76,
  76, 667, 75, 75, 75, 75, 75, 75, 530, 527,
  76, 76, 76, 76, 76, 76, 75, 667, 667, 531,
  75, 75, 667, 535, 76, 536, 534, 75, 76, 76,

  532, 533, 667, 667, 545, 76, 75, 539, 540, 547,
  538, 537, 76, 75, 76, 667, 667, 76, 667, 75,
  75, 76, 550, 543, 541, 75, 542, 76, 76, 75,
  76, 75, 75, 76, 544, 555, 667, 76, 667, 76,
  76, 75, 546, 76, 548, 75, 551, 557, 75, 76,
  75, 549, 75, 76, 75, 76, 76, 553, 76, 75,
  76, 75, 76, 554, 75, 75, 556, 76, 552, 76,
  564, 75, 76, 76, 75, 75, 75, 75, 76, 76,
  667, 667, 76, 76, 76, 76, 559, 75, 560, 562,
  667, 561, 75, 558, 75, 76, 75, 75, 565, 575,

  76, 667, 76, 563, 76, 76, 75, 76, 75, 568,
  75, 75, 75, 75, 76, 566, 76, 574, 76, 76,
  76, 76, 75, 75, 75, 567, 75, 75, 75, 576,
  76, 76, 76, 75, 76, 76, 76, 667, 75, 75,
  75, 76, 580, 667, 75, 579, 76, 76, 76, 577,
  578, 582, 76, 75, 667, 667, 75, 75, 583, 667,
  75, 76, 581, 584, 76, 76, 75, 585, 76, 75,
  75, 589, 667, 75, 76, 75, 586, 76, 76, 76,
  587, 76, 75, 76, 75, 75, 75, 595, 75, 75,
  76, 75, 76, 76, 76, 76, 76, 76, 75, 76,

  602, 667, 75, 590, 667, 667, 76, 588, 76, 591,
  76, 667, 596, 592, 75, 75, 75, 667, 75, 594,
  75, 667, 76, 76, 76, 603, 76, 75, 76, 593,
  667, 75, 75, 75, 75, 76, 597, 75, 606, 76,
  76, 76, 76, 75, 75, 76, 75, 667, 604, 607,
  608, 76, 76, 605, 76, 610, 75, 75, 75, 667,
  75, 75, 609, 75, 76, 76, 76, 612, 76, 76,
  611, 76, 667, 75, 667, 75, 75, 667, 75, 613,
  614, 76, 617, 76, 76, 626, 76, 75, 75, 667,
  75, 75, 627, 622, 615, 76, 76, 616, 76, 76,

  667, 75, 667, 625, 75, 667, 667, 75, 631, 76,
  629, 623, 76, 624, 630, 76, 75, 75, 75, 667,
  632, 638, 75, 667, 76, 76, 76, 628, 667, 76,
  76, 75, 641, 75, 667, 75, 633, 626, 75, 76,
  642, 76, 75, 76, 627, 667, 76, 75, 667, 667,
  76, 75, 75, 634, 75, 76, 635, 640, 75, 76,
  76, 75, 76, 75, 639, 641, 76, 75, 75, 76,
  75, 76, 75, 642, 644, 76, 76, 667, 76, 75,
  76, 667, 667, 643, 75, 646, 667, 76, 75, 645,
  650, 651, 76, 649, 75, 75, 76, 652, 75, 331,

  75, 75, 76, 76, 75, 653, 76, 654, 76, 76,
  75, 75, 76, 655, 75, 667, 75, 75, 76, 76,
  75, 656, 76, 75, 76, 76, 667, 657, 76, 667,
  667, 76, 75, 660, 658, 75, 667, 661, 659, 662,
  76, 663, 667, 76, 667, 667, 667, 667, 667, 667,
  667, 667, 666, 664, 667, 667, 667, 667, 667, 665,
  55, 55, 55, 55, 55, 55, 55, 57, 57, 57,
  57, 57, 57, 57, 60, 60, 60, 60, 60, 60,
  60, 63, 63, 63, 63, 63, 63, 63, 77, 77,
  77, 77, 169, 169, 169, 169, 169, 169, 169, 171,

  171, 171, 171, 171, 171, 171, 175, 175, 667, 175,
  175, 175, 175, 177, 667, 667, 667, 667, 177, 180,
  180, 667, 180, 180, 180, 180, 306, 306, 306, 307,
  667, 307, 307, 431, 431, 667, 431, 431, 431, 431,
  473, 473, 667, 473, 473, 473, 473, 500, 500, 11,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,

  667
};

static yyconst short int yy_chk[2002] = { 0,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 2, 16, 51, 16, 2, 19, 2, 21, 29,
  21, 23, 23, 63, 31, 63, 2, 29, 51, 19,
  681, 33, 31, 21, 30, 33, 35, 167, 37, 33,
  35, 50, 30, 31, 35, 33, 37, 31, 33, 50,
  35, 31, 167, 35, 30, 30, 36, 31, 678, 38,

  31, 37, 637, 54, 36, 54, 30, 38, 48, 67,
  30, 30, 30, 32, 50, 64, 48, 64, 54, 36,
  636, 32, 67, 38, 620, 41, 36, 48, 47, 36,
  38, 38, 32, 41, 42, 618, 47, 39, 601, 32,
  32, 39, 42, 32, 70, 39, 32, 437, 41, 437,
  600, 39, 32, 34, 39, 40, 39, 70, 41, 40,
  47, 34, 47, 40, 41, 47, 42, 43, 42, 40,
  42, 43, 40, 626, 44, 43, 599, 598, 44, 573,
  626, 43, 44, 34, 43, 34, 34, 43, 44, 34,
  572, 571, 34, 44, 44, 34, 45, 68, 45, 68,

  45, 77, 68, 570, 45, 78, 79, 45, 519, 77,
  518, 45, 45, 78, 79, 45, 45, 46, 45, 49,
  45, 46, 516, 49, 46, 46, 49, 49, 71, 80,
  71, 46, 81, 49, 46, 515, 49, 80, 82, 79,
  81, 83, 78, 71, 85, 84, 82, 86, 87, 83,
  88, 80, 85, 84, 89, 86, 87, 514, 88, 82,
  83, 90, 89, 91, 93, 82, 84, 85, 81, 90,
  92, 91, 93, 88, 85, 94, 95, 474, 92, 86,
  99, 96, 441, 94, 95, 86, 440, 439, 99, 96,
  87, 89, 97, 92, 93, 93, 93, 90, 98, 91,

  97, 93, 96, 92, 100, 96, 98, 101, 102, 438,
  103, 94, 100, 436, 95, 101, 102, 99, 103, 98,
  105, 106, 104, 97, 107, 109, 100, 108, 105, 106,
  104, 101, 107, 109, 110, 108, 98, 432, 336, 111,
  103, 379, 110, 101, 102, 104, 108, 111, 336, 104,
  105, 106, 336, 112, 113, 331, 104, 114, 116, 307,
  107, 112, 113, 109, 115, 114, 116, 110, 306, 181,
  179, 118, 115, 117, 120, 119, 111, 111, 116, 118,
  121, 117, 120, 119, 123, 178, 124, 177, 121, 176,
  174, 114, 123, 115, 124, 112, 119, 117, 115, 122,

  119, 115, 115, 118, 125, 117, 123, 122, 119, 126,
  120, 117, 125, 171, 169, 168, 119, 126, 127, 61,
  59, 122, 121, 123, 128, 129, 127, 124, 124, 130,
  131, 122, 128, 129, 56, 132, 133, 130, 131, 53,
  126, 135, 125, 132, 133, 52, 134, 128, 136, 135,
  138, 139, 129, 131, 134, 142, 136, 25, 138, 139,
  20, 141, 140, 142, 182, 133, 144, 18, 130, 141,
  140, 14, 182, 134, 144, 138, 13, 145, 142, 135,
  136, 137, 138, 137, 137, 145, 11, 139, 8, 144,
  143, 137, 7, 137, 140, 146, 137, 141, 143, 137,

  137, 147, 137, 146, 150, 148, 149, 145, 151, 147,
  6, 153, 150, 148, 149, 143, 151, 5, 152, 153,
  147, 154, 143, 4, 147, 148, 152, 155, 156, 154,
  157, 146, 3, 149, 153, 155, 156, 147, 157, 158,
  151, 150, 159, 161, 0, 160, 162, 158, 152, 163,
  159, 161, 154, 160, 162, 156, 155, 163, 164, 173,
  152, 173, 0, 166, 165, 0, 164, 156, 157, 159,
  161, 166, 165, 158, 173, 160, 163, 183, 162, 184,
  186, 185, 0, 0, 187, 183, 188, 184, 186, 185,
  164, 165, 187, 189, 188, 190, 191, 192, 194, 166,

  185, 189, 195, 190, 191, 192, 194, 193, 0, 196,
  195, 0, 197, 0, 183, 193, 187, 196, 188, 192,
  197, 195, 189, 198, 0, 200, 191, 193, 199, 190,
  201, 198, 196, 200, 202, 203, 199, 204, 201, 0,
  205, 206, 202, 203, 198, 204, 207, 199, 205, 206,
  208, 209, 210, 211, 207, 0, 0, 210, 208, 209,
  206, 211, 200, 201, 206, 210, 212, 0, 202, 208,
  213, 214, 0, 203, 212, 213, 215, 216, 217, 214,
  205, 0, 213, 213, 215, 216, 217, 218, 0, 212,
  219, 220, 221, 212, 0, 218, 210, 222, 219, 220,

  221, 217, 213, 223, 224, 222, 225, 227, 218, 228,
  216, 223, 224, 226, 225, 227, 0, 228, 0, 0,
  0, 226, 229, 230, 220, 224, 225, 222, 219, 221,
  229, 230, 231, 226, 0, 0, 232, 234, 0, 233,
  231, 235, 228, 225, 232, 234, 227, 233, 0, 235,
  236, 237, 0, 238, 240, 231, 230, 239, 236, 237,
  234, 238, 240, 241, 235, 239, 242, 0, 243, 0,
  244, 241, 0, 240, 242, 232, 243, 233, 244, 245,
  239, 246, 247, 0, 248, 249, 250, 245, 236, 246,
  247, 243, 248, 249, 250, 251, 252, 244, 253, 254,

  242, 255, 256, 251, 252, 257, 253, 254, 259, 255,
  256, 261, 258, 257, 0, 263, 259, 260, 0, 261,
  258, 262, 249, 263, 0, 260, 255, 0, 264, 262,
  0, 254, 253, 251, 257, 258, 264, 260, 266, 256,
  259, 0, 267, 262, 265, 265, 266, 0, 268, 265,
  267, 269, 270, 263, 260, 264, 268, 265, 271, 269,
  270, 266, 272, 273, 275, 274, 271, 276, 277, 278,
  272, 273, 275, 274, 269, 276, 277, 278, 270, 0,
  267, 0, 279, 280, 0, 0, 281, 268, 274, 272,
  279, 280, 278, 275, 281, 271, 282, 283, 284, 285,

  286, 273, 287, 288, 282, 283, 284, 285, 286, 279,
  287, 288, 289, 0, 290, 0, 0, 291, 292, 298,
  289, 280, 290, 293, 281, 291, 292, 298, 294, 0,
  282, 293, 0, 288, 284, 295, 294, 285, 286, 297,
  291, 292, 293, 295, 296, 299, 290, 297, 300, 301,
  289, 294, 296, 299, 293, 302, 300, 301, 303, 0,
  304, 308, 295, 302, 309, 310, 303, 296, 304, 308,
  300, 297, 309, 310, 311, 0, 312, 302, 313, 301,
  314, 316, 311, 299, 312, 317, 313, 318, 314, 316,
  319, 321, 322, 317, 323, 318, 303, 312, 319, 321,

  322, 324, 323, 325, 326, 328, 327, 309, 0, 324,
  329, 325, 326, 328, 327, 317, 318, 323, 329, 330,
  332, 321, 335, 0, 333, 332, 334, 330, 322, 327,
  325, 326, 333, 332, 334, 337, 338, 324, 339, 340,
  324, 341, 0, 337, 338, 342, 339, 340, 0, 341,
  334, 333, 343, 342, 335, 345, 332, 344, 330, 337,
  343, 346, 347, 345, 335, 344, 0, 0, 335, 346,
  347, 348, 338, 0, 339, 343, 349, 350, 340, 348,
  344, 342, 352, 347, 349, 350, 353, 354, 346, 357,
  352, 355, 356, 358, 353, 354, 349, 357, 359, 355,

  356, 358, 360, 361, 362, 363, 359, 365, 366, 368,
  360, 361, 362, 363, 367, 365, 366, 368, 352, 357,
  0, 0, 367, 369, 0, 354, 370, 355, 356, 353,
  365, 369, 360, 367, 370, 371, 363, 372, 373, 374,
  362, 0, 0, 371, 375, 372, 373, 374, 376, 370,
  369, 377, 375, 378, 381, 382, 376, 0, 0, 377,
  383, 378, 381, 382, 384, 375, 374, 0, 383, 385,
  377, 386, 384, 381, 387, 376, 373, 385, 389, 386,
  0, 388, 387, 390, 378, 391, 389, 392, 382, 388,
  393, 390, 0, 391, 394, 392, 383, 0, 393, 0,

  384, 389, 394, 395, 397, 387, 398, 385, 388, 386,
  399, 395, 397, 0, 398, 400, 401, 0, 399, 391,
  402, 394, 403, 400, 401, 392, 404, 398, 402, 0,
  403, 405, 406, 399, 404, 407, 408, 397, 409, 405,
  406, 411, 410, 407, 408, 412, 409, 413, 414, 411,
  410, 415, 418, 412, 417, 413, 414, 419, 404, 415,
  418, 420, 417, 405, 421, 419, 408, 410, 0, 420,
  413, 422, 421, 0, 409, 423, 417, 0, 415, 422,
  424, 414, 425, 423, 419, 418, 426, 421, 424, 427,
  425, 417, 428, 430, 426, 419, 433, 427, 434, 435,

  428, 430, 442, 443, 433, 444, 434, 435, 0, 445,
  442, 443, 446, 444, 0, 0, 426, 445, 425, 433,
  446, 427, 434, 430, 447, 449, 448, 451, 450, 452,
  453, 454, 447, 449, 448, 451, 450, 452, 453, 454,
  0, 455, 0, 456, 457, 459, 460, 445, 448, 455,
  446, 456, 457, 459, 460, 0, 0, 461, 462, 0,
  463, 464, 465, 449, 450, 461, 462, 452, 463, 464,
  465, 0, 467, 468, 469, 470, 471, 472, 462, 456,
  467, 468, 469, 470, 471, 472, 475, 0, 0, 462,
  476, 477, 0, 464, 475, 467, 463, 478, 476, 477,

  462, 462, 0, 0, 479, 478, 480, 470, 471, 481,
  469, 468, 479, 482, 480, 0, 0, 481, 0, 483,
  484, 482, 485, 477, 475, 486, 476, 483, 484, 487,
  485, 488, 489, 486, 478, 491, 0, 487, 0, 488,
  489, 492, 480, 491, 482, 494, 486, 495, 496, 492,
  497, 483, 498, 494, 499, 495, 496, 488, 497, 503,
  498, 501, 499, 489, 502, 504, 492, 503, 487, 501,
  505, 506, 502, 504, 507, 508, 509, 511, 505, 506,
  0, 0, 507, 508, 509, 511, 499, 510, 501, 503,
  0, 502, 512, 498, 520, 510, 521, 522, 508, 523,

  512, 0, 520, 504, 521, 522, 524, 523, 525, 511,
  527, 530, 531, 532, 524, 509, 525, 520, 527, 530,
  531, 532, 533, 534, 535, 510, 536, 537, 538, 524,
  533, 534, 535, 539, 536, 537, 538, 0, 540, 541,
  543, 539, 534, 0, 542, 531, 540, 541, 543, 527,
  530, 538, 542, 544, 0, 0, 546, 548, 539, 0,
  549, 544, 536, 540, 546, 548, 551, 542, 549, 552,
  553, 554, 0, 556, 551, 558, 544, 552, 553, 554,
  548, 556, 560, 558, 559, 561, 562, 563, 565, 566,
  560, 567, 559, 561, 562, 563, 565, 566, 568, 567,

  574, 0, 576, 556, 0, 0, 568, 552, 574, 559,
  576, 0, 566, 560, 577, 578, 579, 0, 580, 562,
  581, 0, 577, 578, 579, 576, 580, 582, 581, 561,
  0, 583, 584, 585, 586, 582, 568, 587, 579, 583,
  584, 585, 586, 588, 590, 587, 591, 0, 577, 580,
  582, 588, 590, 578, 591, 587, 592, 593, 594, 0,
  596, 603, 584, 597, 592, 593, 594, 590, 596, 603,
  588, 597, 0, 604, 0, 605, 606, 0, 608, 592,
  593, 604, 597, 605, 606, 607, 608, 610, 611, 0,
  607, 609, 607, 603, 594, 610, 611, 594, 607, 609,

  0, 612, 0, 606, 613, 0, 0, 614, 610, 612,
  608, 604, 613, 605, 609, 614, 615, 616, 617, 0,
  611, 622, 623, 0, 615, 616, 617, 607, 0, 622,
  623, 624, 627, 625, 0, 629, 613, 628, 630, 624,
  627, 625, 628, 629, 628, 0, 630, 631, 0, 0,
  628, 632, 633, 616, 634, 631, 617, 625, 635, 632,
  633, 639, 634, 640, 624, 641, 635, 644, 643, 639,
  645, 640, 646, 641, 632, 644, 643, 0, 645, 649,
  646, 0, 0, 631, 650, 635, 0, 649, 652, 633,
  640, 643, 650, 639, 651, 653, 652, 645, 654, 657,

  655, 656, 651, 653, 657, 646, 654, 650, 655, 656,
  658, 660, 657, 651, 659, 0, 663, 661, 658, 660,
  664, 652, 659, 662, 663, 661, 0, 653, 664, 0,
  0, 662, 665, 656, 654, 666, 0, 659, 655, 661,
  665, 662, 0, 666, 0, 0, 0, 0, 0, 0,
  0, 0, 665, 663, 0, 0, 0, 0, 0, 664,
  668, 668, 668, 668, 668, 668, 668, 669, 669, 669,
  669, 669, 669, 669, 670, 670, 670, 670, 670, 670,
  670, 671, 671, 671, 671, 671, 671, 671, 672, 672,
  672, 672, 673, 673, 673, 673, 673, 673, 673, 674,

  674, 674, 674, 674, 674, 674, 675, 675, 0, 675,
  675, 675, 675, 676, 0, 0, 0, 0, 676, 677,
  677, 0, 677, 677, 677, 677, 679, 679, 679, 680,
  0, 680, 680, 682, 682, 0, 682, 682, 682, 682,
  683, 683, 0, 683, 683, 683, 683, 684, 684, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,
  667, 667, 667, 667, 667, 667, 667, 667, 667, 667,

  667
};

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
yy_lp = yy_full_lp; /* restore orig. accepting pos. */ \
yy_state_ptr = yy_full_state; /* restore orig. state */ \
yy_current_state = *yy_state_ptr; /* restore curr. state */ \
++yy_lp; \
goto find_rule; \
}
static int yy_more_flag = 0;
static int yy_more_len = 0;
#define yymore() (yy_more_flag = 1)
#define YY_MORE_ADJ yy_more_len
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#define INITIAL 0
/*

    YABASIC ---  a simple Basic Interpreter
    written by Marc-Oliver Ihm 1995-2005
    homepage: www.yabasic.de

    FLEX part
     
    This file is part of yabasic and may be copied only 
    under the terms of either the Artistic License or 
    the GNU General Public License (GPL), both of which 
    can be found at www.yabasic.de

*/

#include <string.h>
#undef WINDOWS

#include "bison.h"		/* get tokens from BISON */
#ifndef YABASIC_INCLUDED
#include "yabasic.h"		/* definitions of yabasic */
#endif
extern int main_lineno;		/* defined in yabasic.bison: line number of main file */
extern int yylineno;		/* defined in yabasic.bison: line number of main file */
int import_lib (char *);	/* import library */

#define MAX_INCLUDE_DEPTH 5
#define MAX_INCLUDE_NUMBER 100
static YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH];	/* stack for included libraries */
int include_stack_ptr;		/* current position in libfile_stack */
struct libfile_name *libfile_stack[MAX_INCLUDE_DEPTH];	/* stack for library file names */
int libfile_chain_length = 0;	/* length of libfile_chain */
struct libfile_name *libfile_chain[MAX_INCLUDE_NUMBER];	/* list of all library file names */
struct libfile_name *currlib;	/* current libfile as relevant to bison */
int inlib;			/* true, while in library */
int fi_pending = 0;		/* true, if within a short if */
int flex_line = 0;		/* line number counted in flex */
#define PRELNO 1

#define PASTLNO 2

#define IMPORT 3

#define IMPORT_DONE 4


/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO ((void));
#else
extern int yywrap YY_PROTO ((void));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO ((int c, char *buf_ptr));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO ((char *, yyconst char *, int));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO ((yyconst char *));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO ((void));
#else
static int input YY_PROTO ((void));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO ((int new_state));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO ((void));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO ((void));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		yy_current_buffer->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

YY_DECL
{
  register yy_state_type yy_current_state;
  register char *yy_cp = NULL, *yy_bp = NULL;
  register int yy_act;



  if (yy_init)
    {
      yy_init = 0;

#ifdef YY_USER_INIT
      YY_USER_INIT;
#endif

      if (!yy_start)
	yy_start = 1;		/* first start state */

      if (!yyin)
	yyin = stdin;

      if (!yyout)
	yyout = stdout;

      if (!yy_current_buffer)
	yy_current_buffer = yy_create_buffer (yyin, YY_BUF_SIZE);

      yy_load_buffer_state ();
    }

  while (1)			/* loops until end-of-file is reached */
    {
      yy_more_len = 0;
      if (yy_more_flag)
	{
	  yy_more_len = yy_c_buf_p - yytext_ptr;
	  yy_more_flag = 0;
	}
      yy_cp = yy_c_buf_p;

      /* Support of yytext. */
      *yy_cp = yy_hold_char;

      /* yy_bp points to the position in yy_ch_buf of the start of
       * the current run.
       */
      yy_bp = yy_cp;

      yy_current_state = yy_start;
      yy_current_state += YY_AT_BOL ();
      yy_state_ptr = yy_state_buf;
      *yy_state_ptr++ = yy_current_state;
    yy_match:
      do
	{
	  register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI (*yy_cp)];
	  while (yy_chk[yy_base[yy_current_state] + yy_c] !=
		 yy_current_state)
	    {
	      yy_current_state = (int) yy_def[yy_current_state];
	      if (yy_current_state >= 668)
		yy_c = yy_meta[(unsigned int) yy_c];
	    }
	  yy_current_state =
	      yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	  *yy_state_ptr++ = yy_current_state;
	  ++yy_cp;
	}
      while (yy_base[yy_current_state] != 1950);

    yy_find_action:
      yy_current_state = *--yy_state_ptr;
      yy_lp = yy_accept[yy_current_state];
    find_rule:			/* we branch to this label when backing up */
      for (;;)			/* until we find what rule we matched */
	{
	  if (yy_lp && yy_lp < yy_accept[yy_current_state + 1])
	    {
	      yy_act = yy_acclist[yy_lp];
	      if (yy_act & YY_TRAILING_HEAD_MASK ||
		  yy_looking_for_trail_begin)
		{
		  if (yy_act == yy_looking_for_trail_begin)
		    {
		      yy_looking_for_trail_begin = 0;
		      yy_act &= ~YY_TRAILING_HEAD_MASK;
		      break;
		    }
		}
	      else if (yy_act & YY_TRAILING_MASK)
		{
		  yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
		  yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
		}
	      else
		{
		  yy_full_match = yy_cp;
		  yy_full_state = yy_state_ptr;
		  yy_full_lp = yy_lp;
		  break;
		}
	      ++yy_lp;
	      goto find_rule;
	    }
	  --yy_cp;
	  yy_current_state = *--yy_state_ptr;
	  yy_lp = yy_accept[yy_current_state];
	}

      YY_DO_BEFORE_ACTION;


    do_action:			/* This label is used only to access EOF actions. */


      switch (yy_act)
	{			/* beginning of action switch */
	case YY_STATE_EOF (INITIAL):
	case YY_STATE_EOF (PRELNO):
	case YY_STATE_EOF (PASTLNO):
	case YY_STATE_EOF (IMPORT):
	case YY_STATE_EOF (IMPORT_DONE):
	  {
	    if (--include_stack_ptr < 0)
	      {
		return tEOPROG;
	      }
	    else
	      {
		if (!is_bound)
		  {
		    yy_delete_buffer (YY_CURRENT_BUFFER);
		    yy_switch_to_buffer (include_stack[include_stack_ptr]);
		  }
		flex_line += yylval.sep = -1;
		return tSEP;
	      }
	  }
	YY_BREAK case 1:
	  YY_RULE_SETUP
	  {
	    BEGIN (INITIAL);
	  }			/* ignore whitespace */
	YY_BREAK case 2:
	  YY_RULE_SETUP
	  {
	    BEGIN (PRELNO);
	    return tLABEL;
	  }
	YY_BREAK case 3:
	  YY_RULE_SETUP
	  {
	    BEGIN (PASTLNO);
	    yylval.symbol = (char *) my_strdup (yytext);
	    return tSYMBOL;
	  }
	YY_BREAK case 4:
	  YY_RULE_SETUP
	  {
	    BEGIN (INITIAL);
	    flex_line += yylval.sep = 0;
	    yyless (0);
	    return tSEP;
	  }
	YY_BREAK case 5:
	  YY_RULE_SETUP
	  {
	    if (fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    BEGIN (INITIAL);
	    flex_line += yylval.sep = 1;
	    return tSEP;
	  }
	YY_BREAK case 6:
	  YY_RULE_SETUP
	  {
	    if (fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    if (interactive && !inlib)
	      {
		return tEOPROG;
	      }
	    else
	      {
		flex_line += yylval.sep = 2;
		return tSEP;
	      }
	  }
	YY_BREAK case 7:
	  YY_RULE_SETUP
	  {
	    if (fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    flex_line += yylval.sep = 1;
	    return tSEP;
	  }
	YY_BREAK case 8:
	  YY_RULE_SETUP
	  {
	    if (fi_pending && check_compat)
	      error_with_line (WARNING,
			       "short-if has changed in version 2.71",
			       flex_line);
	    flex_line += yylval.sep = 0;
	    return tSEP;
	  }
	YY_BREAK case 9:
	  YY_RULE_SETUP
	  {
	    flex_line += yylval.sep = 0;
	    return tSEP;
	  }			/* comments span 'til end of line */
	YY_BREAK case 10:
	  YY_RULE_SETUP
	  {
	    flex_line += yylval.sep = 0;
	    return tSEP;
	  }			/* comments span 'til end of line */
	YY_BREAK case 11:
	  YY_RULE_SETUP
	  {
	    if (fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    flex_line += yylval.sep = 1;
	    return tSEP;
	  }
	YY_BREAK case 12:
	  YY_RULE_SETUP
	  {
	    yymore ();
	  }
	YY_BREAK case 13:
	  YY_RULE_SETUP
	  {
	    BEGIN (IMPORT);
	  }
	YY_BREAK case 14:
	  YY_RULE_SETUP
	  {
	    if (!import_lib (yytext))
	      return 0;
	    BEGIN (IMPORT_DONE);
	    return tIMPORT;
	  }
	YY_BREAK case 15:
	  YY_RULE_SETUP
	  {
	    if (yytext[0] == '\n' && fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    BEGIN (INITIAL);
	    yyless (0);
	    flex_line += yylval.sep = 0;
	    return tSEP;
	  }
	YY_BREAK case 16:
	  YY_RULE_SETUP
	  {
	    char *where = strpbrk (yytext, " \t\r\f\v");
	    yylval.docu = (char *) my_strdup (where ? where + 1 : NULL);
	    return tDOCU;
	  }
	YY_BREAK case 17:
	  YY_RULE_SETUP
	  {
	    flex_line += yylval.sep = 1;
	    return tSEP;
	  }			/* '#' as first character may introduce comments too */
	YY_BREAK case 18:
	  YY_RULE_SETUP
	  {
	    flex_line += yylval.sep = 1;
	    return tSEP;
	  }			/* ' as first character may introduce comments too */
	YY_BREAK case 19:
	  YY_RULE_SETUP return tEXECUTE;
	YY_BREAK case 20:
	  YY_RULE_SETUP return tEXECUTE2;
	YY_BREAK case 21:
	  YY_RULE_SETUP return tCOMPILE;
	YY_BREAK case 22:
	  YY_RULE_SETUP return tRUNTIME_CREATED_SUB;
	YY_BREAK case 23:
	  YY_RULE_SETUP return tENDSUB;
	YY_BREAK case 24:
	  YY_RULE_SETUP return tENDIF;
	YY_BREAK case 25:
	  YY_RULE_SETUP return tENDIF;
	YY_BREAK case 26:
	  YY_RULE_SETUP return tWEND;
	YY_BREAK case 27:
	  YY_RULE_SETUP return tWEND;
	YY_BREAK case 28:
	  YY_RULE_SETUP return tSEND;
	YY_BREAK case 29:
	  YY_RULE_SETUP return tSEND;
	YY_BREAK case 30:
	  YY_RULE_SETUP return tSEND;
	YY_BREAK case 31:
	  YY_RULE_SETUP return tSEND;
	YY_BREAK case 32:
	  YY_RULE_SETUP return tEXPORT;
	YY_BREAK case 33:
	  YY_RULE_SETUP return tERROR;
	YY_BREAK case 34:
	  YY_RULE_SETUP return tFOR;
	YY_BREAK case 35:
	  YY_RULE_SETUP return tBREAK;
	YY_BREAK case 36:
	  YY_RULE_SETUP return tSWITCH;
	YY_BREAK case 37:
	  YY_RULE_SETUP return tCASE;
	YY_BREAK case 38:
	  YY_RULE_SETUP return tDEFAULT;
	YY_BREAK case 39:
	  YY_RULE_SETUP return tLOOP;
	YY_BREAK case 40:
	  YY_RULE_SETUP return tDO;
	YY_BREAK case 41:
	  YY_RULE_SETUP return tTO;
	YY_BREAK case 42:
	  YY_RULE_SETUP return tAS;
	YY_BREAK case 43:
	  YY_RULE_SETUP return tREADING;
	YY_BREAK case 44:
	  YY_RULE_SETUP return tWRITING;
	YY_BREAK case 45:
	  YY_RULE_SETUP return tSTEP;
	YY_BREAK case 46:
	  YY_RULE_SETUP return tNEXT;
	YY_BREAK case 47:
	  YY_RULE_SETUP return tWHILE;
	YY_BREAK case 48:
	  YY_RULE_SETUP return tWEND;
	YY_BREAK case 49:
	  YY_RULE_SETUP return tREPEAT;
	YY_BREAK case 50:
	  YY_RULE_SETUP return tUNTIL;
	YY_BREAK case 51:
	  YY_RULE_SETUP return tGOTO;
	YY_BREAK case 52:
	  YY_RULE_SETUP return tGOSUB;
	YY_BREAK case 53:
	  YY_RULE_SETUP return tSUB;
	YY_BREAK case 54:
	  YY_RULE_SETUP return tSUB;
	YY_BREAK case 55:
	  YY_RULE_SETUP return tLOCAL;
	YY_BREAK case 56:
	  YY_RULE_SETUP return tSTATIC;
	YY_BREAK case 57:
	  YY_RULE_SETUP return tON;
	YY_BREAK case 58:
	  YY_RULE_SETUP return tINTERRUPT;
	YY_BREAK case 59:
	  YY_RULE_SETUP return tCONTINUE;
	YY_BREAK case 60:
	  YY_RULE_SETUP return tLABEL;
	YY_BREAK case 61:
	  YY_RULE_SETUP return tIF;
	YY_BREAK case 62:
	  YY_RULE_SETUP return tTHEN;
	YY_BREAK case 63:
	  YY_RULE_SETUP return tELSE;
	YY_BREAK case 64:
	  YY_RULE_SETUP return tELSIF;
	YY_BREAK case 65:
	  YY_RULE_SETUP return tELSIF;
	YY_BREAK case 66:
	  YY_RULE_SETUP return tENDIF;
	YY_BREAK case 67:
	  YY_RULE_SETUP return tENDIF;
	YY_BREAK case 68:
	  YY_RULE_SETUP return tOPEN;
	YY_BREAK case 69:
	  YY_RULE_SETUP return tCLOSE;
	YY_BREAK case 70:
	  YY_RULE_SETUP return tSEEK;
	YY_BREAK case 71:
	  YY_RULE_SETUP return tTELL;
	YY_BREAK case 72:
	  YY_RULE_SETUP return tPRINT;
	YY_BREAK case 73:
	  YY_RULE_SETUP return tUSING;
	YY_BREAK case 74:
	  YY_RULE_SETUP return tREVERSE;
	YY_BREAK case 75:
	  YY_RULE_SETUP return tCOLOUR;
	YY_BREAK case 76:
	  YY_RULE_SETUP return tCOLOUR;
	YY_BREAK case 77:
	  YY_RULE_SETUP return tBACKCOLOUR;
	YY_BREAK case 78:
	  YY_RULE_SETUP return tBACKCOLOUR;
	YY_BREAK case 79:
	  YY_RULE_SETUP return tPRINT;
	YY_BREAK case 80:
	  YY_RULE_SETUP return tINPUT;
	YY_BREAK case 81:
	  YY_RULE_SETUP return tRETURN;
	YY_BREAK case 82:
	  YY_RULE_SETUP return tDIM;
	YY_BREAK case 83:
	  YY_RULE_SETUP return tDIM;
	YY_BREAK case 84:
	  YY_RULE_SETUP return tEND;
	YY_BREAK case 85:
	  YY_RULE_SETUP return tEXIT;
	YY_BREAK case 86:
	  YY_RULE_SETUP return tREAD;
	YY_BREAK case 87:
	  YY_RULE_SETUP return tDATA;
	YY_BREAK case 88:
	  YY_RULE_SETUP return tRESTORE;
	YY_BREAK case 89:
	  YY_RULE_SETUP return tAND;
	YY_BREAK case 90:
	  YY_RULE_SETUP return tOR;
	YY_BREAK case 91:
	  YY_RULE_SETUP return tNOT;
	YY_BREAK case 92:
	  YY_RULE_SETUP return tEOR;
	YY_BREAK case 93:
	  YY_RULE_SETUP return tEOR;
	YY_BREAK case 94:
	  YY_RULE_SETUP return tWINDOW;
	YY_BREAK case 95:
	  YY_RULE_SETUP return tORIGIN;
	YY_BREAK case 96:
	  YY_RULE_SETUP return tPRINTER;
	YY_BREAK case 97:
	  YY_RULE_SETUP return tDOT;
	YY_BREAK case 98:
	  YY_RULE_SETUP return tLINE;
	YY_BREAK case 99:
	  YY_RULE_SETUP return tCURVE;
	YY_BREAK case 100:
	  YY_RULE_SETUP return tCIRCLE;
	YY_BREAK case 101:
	  YY_RULE_SETUP return tTRIANGLE;
	YY_BREAK case 102:
	  YY_RULE_SETUP return tCLEAR;
	YY_BREAK case 103:
	  YY_RULE_SETUP return tFILL;
	YY_BREAK case 104:
	  YY_RULE_SETUP return tFILL;
	YY_BREAK case 105:
	  YY_RULE_SETUP return tTEXT;
	YY_BREAK case 106:
	  YY_RULE_SETUP return tRECT;
	YY_BREAK case 107:
	  YY_RULE_SETUP return tRECT;
	YY_BREAK case 108:
	  YY_RULE_SETUP return tRECT;
	YY_BREAK case 109:
	  YY_RULE_SETUP return tPUTBIT;
	YY_BREAK case 110:
	  YY_RULE_SETUP return tPUTBIT;
	YY_BREAK case 111:
	  YY_RULE_SETUP return tPUTBIT;
	YY_BREAK case 112:
	  YY_RULE_SETUP return tGETBIT;
	YY_BREAK case 113:
	  YY_RULE_SETUP return tGETBIT;
	YY_BREAK case 114:
	  YY_RULE_SETUP return tGETBIT;
	YY_BREAK case 115:
	  YY_RULE_SETUP return tPUTCHAR;
	YY_BREAK case 116:
	  YY_RULE_SETUP return tGETCHAR;
	YY_BREAK case 117:
	  YY_RULE_SETUP return tNEW;
	YY_BREAK case 118:
	  YY_RULE_SETUP return tWAIT;
	YY_BREAK case 119:
	  YY_RULE_SETUP return tWAIT;
	YY_BREAK case 120:
	  YY_RULE_SETUP return tWAIT;
	YY_BREAK case 121:
	  YY_RULE_SETUP return tBELL;
	YY_BREAK case 122:
	  YY_RULE_SETUP return tBELL;
	YY_BREAK case 123:
	  YY_RULE_SETUP return tLET;
	YY_BREAK case 124:
	  YY_RULE_SETUP return tARDIM;
	YY_BREAK case 125:
	  YY_RULE_SETUP return tARDIM;
	YY_BREAK case 126:
	  YY_RULE_SETUP return tARSIZE;
	YY_BREAK case 127:
	  YY_RULE_SETUP
	  {
	    yylval.symbol = (char *) my_strdup ("numparams");
	    return tSYMBOL;
	  }
	YY_BREAK case 128:
	  YY_RULE_SETUP return tBIND;
	YY_BREAK case 129:
	  YY_RULE_SETUP return tSIN;
	YY_BREAK case 130:
	  YY_RULE_SETUP return tASIN;
	YY_BREAK case 131:
	  YY_RULE_SETUP return tCOS;
	YY_BREAK case 132:
	  YY_RULE_SETUP return tACOS;
	YY_BREAK case 133:
	  YY_RULE_SETUP return tTAN;
	YY_BREAK case 134:
	  YY_RULE_SETUP return tATAN;
	YY_BREAK case 135:
	  YY_RULE_SETUP return tEXP;
	YY_BREAK case 136:
	  YY_RULE_SETUP return tLOG;
	YY_BREAK case 137:
	  YY_RULE_SETUP return tSQRT;
	YY_BREAK case 138:
	  YY_RULE_SETUP return tSQR;
	YY_BREAK case 139:
	  YY_RULE_SETUP return tINT;
	YY_BREAK case 140:
	  YY_RULE_SETUP return tFRAC;
	YY_BREAK case 141:
	  YY_RULE_SETUP return tABS;
	YY_BREAK case 142:
	  YY_RULE_SETUP return tSIG;
	YY_BREAK case 143:
	  YY_RULE_SETUP return tMOD;
	YY_BREAK case 144:
	  YY_RULE_SETUP return tRAN;
	YY_BREAK case 145:
	  YY_RULE_SETUP return tMIN;
	YY_BREAK case 146:
	  YY_RULE_SETUP return tMAX;
	YY_BREAK case 147:
	  YY_RULE_SETUP return tLEFT;
	YY_BREAK case 148:
	  YY_RULE_SETUP return tRIGHT;
	YY_BREAK case 149:
	  YY_RULE_SETUP return tMID;
	YY_BREAK case 150:
	  YY_RULE_SETUP return tLOWER;
	YY_BREAK case 151:
	  YY_RULE_SETUP return tUPPER;
	YY_BREAK case 152:
	  YY_RULE_SETUP return tLTRIM;
	YY_BREAK case 153:
	  YY_RULE_SETUP return tRTRIM;
	YY_BREAK case 154:
	  YY_RULE_SETUP return tTRIM;
	YY_BREAK case 155:
	  YY_RULE_SETUP return tINSTR;
	YY_BREAK case 156:
	  YY_RULE_SETUP return tRINSTR;
	YY_BREAK case 157:
	  YY_RULE_SETUP return tLEN;
	YY_BREAK case 158:
	  YY_RULE_SETUP return tVAL;
	YY_BREAK case 159:
	  YY_RULE_SETUP return tMYEOF;
	YY_BREAK case 160:
	  YY_RULE_SETUP return tSTR;
	YY_BREAK case 161:
	  YY_RULE_SETUP return tINKEY;
	YY_BREAK case 162:
	  YY_RULE_SETUP return tMOUSEX;
	YY_BREAK case 163:
	  YY_RULE_SETUP return tMOUSEY;
	YY_BREAK case 164:
	  YY_RULE_SETUP return tMOUSEB;
	YY_BREAK case 165:
	  YY_RULE_SETUP return tMOUSEB;
	YY_BREAK case 166:
	  YY_RULE_SETUP return tMOUSEMOD;
	YY_BREAK case 167:
	  YY_RULE_SETUP return tMOUSEMOD;
	YY_BREAK case 168:
	  YY_RULE_SETUP return tCHR;
	YY_BREAK case 169:
	  YY_RULE_SETUP return tASC;
	YY_BREAK case 170:
	  YY_RULE_SETUP return tHEX;
	YY_BREAK case 171:
	  YY_RULE_SETUP return tBIN;
	YY_BREAK case 172:
	  YY_RULE_SETUP return tDEC;
	YY_BREAK case 173:
	  YY_RULE_SETUP return tAT;
	YY_BREAK case 174:
	  YY_RULE_SETUP return tAT;
	YY_BREAK case 175:
	  YY_RULE_SETUP return tSCREEN;
	YY_BREAK case 176:
	  YY_RULE_SETUP return tSYSTEM;
	YY_BREAK case 177:
	  YY_RULE_SETUP return tSYSTEM2;
	YY_BREAK case 178:
	  YY_RULE_SETUP return tDATE;
	YY_BREAK case 179:
	  YY_RULE_SETUP return tTIME;
	YY_BREAK case 180:
	  YY_RULE_SETUP return tPEEK;
	YY_BREAK case 181:
	  YY_RULE_SETUP return tPEEK2;
	YY_BREAK case 182:
	  YY_RULE_SETUP return tPOKE;
	YY_BREAK case 183:
	  YY_RULE_SETUP return tTOKEN;
	YY_BREAK case 184:
	  YY_RULE_SETUP return tTOKENALT;
	YY_BREAK case 185:
	  YY_RULE_SETUP return tSPLIT;
	YY_BREAK case 186:
	  YY_RULE_SETUP return tSPLITALT;
	YY_BREAK case 187:
	  YY_RULE_SETUP return tGLOB;
	YY_BREAK case 188:
	  YY_RULE_SETUP return tPOW;
	YY_BREAK case 189:
	  YY_RULE_SETUP return tPOW;
	YY_BREAK case 190:
	  YY_RULE_SETUP return tNEQ;
	YY_BREAK case 191:
	  YY_RULE_SETUP return tLEQ;
	YY_BREAK case 192:
	  YY_RULE_SETUP return tGEQ;
	YY_BREAK case 193:
	  YY_RULE_SETUP return tEQU;
	YY_BREAK case 194:
	  YY_RULE_SETUP return tLTN;
	YY_BREAK case 195:
	  YY_RULE_SETUP return tGTN;
	YY_BREAK case 196:
	  YY_RULE_SETUP return tNOT;
	YY_BREAK case 197:
	  YY_RULE_SETUP
	  {
	    return yytext[0];
	  }
	YY_BREAK case 198:
	  YY_RULE_SETUP
	  {
	    yylval.digits = (char *) my_strdup (yytext);
	    return tDIGITS;
	  }
	YY_BREAK case 199:
	  YY_RULE_SETUP
	  {
	    {
	      double d;
	      sscanf (yytext, "%lg", &d);
	      yylval.fnum = d;
	      return tFNUM;
	    }
	  }
	YY_BREAK case 200:
	  YY_RULE_SETUP
	  {
	    yylval.fnum = 3.1415926535897932;
	    return tFNUM;
	  }
	YY_BREAK case 201:
	  YY_RULE_SETUP
	  {
	    yylval.fnum = 2.7182818284590452;
	    return tFNUM;
	  }
	YY_BREAK case 202:
	  YY_RULE_SETUP
	  {
	    yylval.fnum = 1;
	    return tFNUM;
	  }
	YY_BREAK case 203:
	  YY_RULE_SETUP
	  {
	    yylval.fnum = 0;
	    return tFNUM;
	  }
	YY_BREAK case 204:
	  YY_RULE_SETUP
	  {
	    yylval.symbol = (char *) my_strdup (yytext);
	    return tSYMBOL;
	  }
	  YY_BREAK
/* Symbols with a trailing $-sign are treated special */
	case 205:
	  YY_RULE_SETUP
	  {
	    yylval.symbol = (char *) my_strdup (yytext);
	    return tSTRSYM;
	  }
	YY_BREAK case 206:
	  YY_RULE_SETUP
	  {
	    int cnt;
	    if (yytext[yyleng - 1] == '\n' && fi_pending)
	      {
		fi_pending--;
		yyless (0);
		return tENDIF;
	      }
	    if (yytext[yyleng - 1] == '\n')
	      {
		yylval.string = NULL;
		return tSTRING;
	      }
	    for (cnt = 0; yytext[yyleng - cnt - 2] == '\\'; cnt++);
	    if (cnt % 2)
	      {
		yyless (yyleng - 1);
		yymore ();
	      }
	    else
	      {
		yylval.string = (char *) my_strdup (yytext + 1);
		*(yylval.string + yyleng - 2) = '\0';
		replace (yylval.string);
		return tSTRING;
	      }
	  }
	YY_BREAK case 207:
	  YY_RULE_SETUP
	  {
	    if (isprint (yytext[0]))
	      return yytext[0];
	    else
	      return ' ';
	  }
	YY_BREAK case 208:
	  YY_RULE_SETUP YY_FATAL_ERROR ("flex scanner jammed");
	YY_BREAK case YY_END_OF_BUFFER:
	  {
	    /* Amount of text matched not including the EOB char. */
	    int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

	    /* Undo the effects of YY_DO_BEFORE_ACTION. */
	    *yy_cp = yy_hold_char;
	    YY_RESTORE_YY_MORE_OFFSET
		if (yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW)
	      {
		/* We're scanning a new file or input source.  It's
		 * possible that this happened because the user
		 * just pointed yyin at a new source and called
		 * yylex().  If so, then we have to assure
		 * consistency between yy_current_buffer and our
		 * globals.  Here is the right place to do so, because
		 * this is the first action (other than possibly a
		 * back-up) that will match for the new input source.
		 */
		yy_n_chars = yy_current_buffer->yy_n_chars;
		yy_current_buffer->yy_input_file = yyin;
		yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
	      }

	    /* Note that here we test for yy_c_buf_p "<=" to the position
	     * of the first EOB in the buffer, since yy_c_buf_p will
	     * already have been incremented past the NUL character
	     * (since all states make transitions on EOB to the
	     * end-of-buffer state).  Contrast this with the test
	     * in input().
	     */
	    if (yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars])
	      {			/* This was really a NUL. */
		yy_state_type yy_next_state;

		yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

		yy_current_state = yy_get_previous_state ();

		/* Okay, we're now positioned to make the NUL
		 * transition.  We couldn't have
		 * yy_get_previous_state() go ahead and do it
		 * for us because it doesn't know how to deal
		 * with the possibility of jamming (and we don't
		 * want to build jamming into it because then it
		 * will run more slowly).
		 */

		yy_next_state = yy_try_NUL_trans (yy_current_state);

		yy_bp = yytext_ptr + YY_MORE_ADJ;

		if (yy_next_state)
		  {
		    /* Consume the NUL. */
		    yy_cp = ++yy_c_buf_p;
		    yy_current_state = yy_next_state;
		    goto yy_match;
		  }

		else
		  {
		    yy_cp = yy_c_buf_p;
		    goto yy_find_action;
		  }
	      }

	    else
	      switch (yy_get_next_buffer ())
		{
		case EOB_ACT_END_OF_FILE:
		  {
		    yy_did_buffer_switch_on_eof = 0;

		    if (yywrap ())
		      {
			/* Note: because we've taken care in
			 * yy_get_next_buffer() to have set up
			 * yytext, we can now set up
			 * yy_c_buf_p so that if some total
			 * hoser (like flex itself) wants to
			 * call the scanner after we return the
			 * YY_NULL, it'll still work - another
			 * YY_NULL will get returned.
			 */
			yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

			yy_act = YY_STATE_EOF (YY_START);
			goto do_action;
		      }

		    else
		      {
			if (!yy_did_buffer_switch_on_eof)
			  YY_NEW_FILE;
		      }
		    break;
		  }

		case EOB_ACT_CONTINUE_SCAN:
		  yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

		  yy_current_state = yy_get_previous_state ();

		  yy_cp = yy_c_buf_p;
		  yy_bp = yytext_ptr + YY_MORE_ADJ;
		  goto yy_match;

		case EOB_ACT_LAST_MATCH:
		  yy_c_buf_p = &yy_current_buffer->yy_ch_buf[yy_n_chars];

		  yy_current_state = yy_get_previous_state ();

		  yy_cp = yy_c_buf_p;
		  yy_bp = yytext_ptr + YY_MORE_ADJ;
		  goto yy_find_action;
		}
	    break;
	  }

	default:
	  YY_FATAL_ERROR
	      ("fatal flex scanner internal error--no action found");
	}			/* end of action switch */
    }				/* end of scanning one token */
}				/* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int
yy_get_next_buffer ()
{
  register char *dest = yy_current_buffer->yy_ch_buf;
  register char *source = yytext_ptr;
  register int number_to_move, i;
  int ret_val;

  if (yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1])
    YY_FATAL_ERROR
	("fatal flex scanner internal error--end of buffer missed");

  if (yy_current_buffer->yy_fill_buffer == 0)
    {				/* Don't try to fill the buffer, so this is an EOF. */
      if (yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1)
	{
	  /* We matched a single character, the EOB, so
	   * treat this as a final EOF.
	   */
	  return EOB_ACT_END_OF_FILE;
	}

      else
	{
	  /* We matched some text prior to the EOB, first
	   * process it.
	   */
	  return EOB_ACT_LAST_MATCH;
	}
    }

  /* Try to read more data. */

  /* First move last chars to start of buffer. */
  number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

  for (i = 0; i < number_to_move; ++i)
    *(dest++) = *(source++);

  if (yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING)
    /* don't do the read, it's not guaranteed to return an EOF,
     * just force an EOF
     */
    yy_current_buffer->yy_n_chars = yy_n_chars = 0;

  else
    {
      int num_to_read =
	  yy_current_buffer->yy_buf_size - number_to_move - 1;

      while (num_to_read <= 0)
	{			/* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
	  YY_FATAL_ERROR
	      ("input buffer overflow, can't enlarge buffer because scanner uses REJECT");
#else

	  /* just a shorter name for the current buffer */
	  YY_BUFFER_STATE b = yy_current_buffer;

	  int yy_c_buf_p_offset = (int) (yy_c_buf_p - b->yy_ch_buf);

	  if (b->yy_is_our_buffer)
	    {
	      int new_size = b->yy_buf_size * 2;

	      if (new_size <= 0)
		b->yy_buf_size += b->yy_buf_size / 8;
	      else
		b->yy_buf_size *= 2;

	      b->yy_ch_buf = (char *)
		  /* Include room in for 2 EOB chars. */
		  yy_flex_realloc ((void *) b->yy_ch_buf,
				   b->yy_buf_size + 2);
	    }
	  else
	    /* Can't grow it, we don't own it. */
	    b->yy_ch_buf = 0;

	  if (!b->yy_ch_buf)
	    YY_FATAL_ERROR ("fatal error - scanner input buffer overflow");

	  yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

	  num_to_read = yy_current_buffer->yy_buf_size -
	      number_to_move - 1;
#endif
	}

      if (num_to_read > YY_READ_BUF_SIZE)
	num_to_read = YY_READ_BUF_SIZE;

      /* Read in more data. */
      YY_INPUT ((&yy_current_buffer->yy_ch_buf[number_to_move]),
		yy_n_chars, num_to_read);

      yy_current_buffer->yy_n_chars = yy_n_chars;
    }

  if (yy_n_chars == 0)
    {
      if (number_to_move == YY_MORE_ADJ)
	{
	  ret_val = EOB_ACT_END_OF_FILE;
	  yyrestart (yyin);
	}

      else
	{
	  ret_val = EOB_ACT_LAST_MATCH;
	  yy_current_buffer->yy_buffer_status = YY_BUFFER_EOF_PENDING;
	}
    }

  else
    ret_val = EOB_ACT_CONTINUE_SCAN;

  yy_n_chars += number_to_move;
  yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
  yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

  yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

  return ret_val;
}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type
yy_get_previous_state ()
{
  register yy_state_type yy_current_state;
  register char *yy_cp;

  yy_current_state = yy_start;
  yy_current_state += YY_AT_BOL ();
  yy_state_ptr = yy_state_buf;
  *yy_state_ptr++ = yy_current_state;

  for (yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp)
    {
      register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI (*yy_cp)] : 1);
      while (yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
	{
	  yy_current_state = (int) yy_def[yy_current_state];
	  if (yy_current_state >= 668)
	    yy_c = yy_meta[(unsigned int) yy_c];
	}
      yy_current_state =
	  yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
      *yy_state_ptr++ = yy_current_state;
    }

  return yy_current_state;
}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type
yy_try_NUL_trans (yy_state_type yy_current_state)
#else
static yy_state_type
yy_try_NUL_trans (yy_current_state)
     yy_state_type yy_current_state;
#endif
{
  register int yy_is_jam;

  register YY_CHAR yy_c = 1;
  while (yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
    {
      yy_current_state = (int) yy_def[yy_current_state];
      if (yy_current_state >= 668)
	yy_c = yy_meta[(unsigned int) yy_c];
    }
  yy_current_state =
      yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
  yy_is_jam = (yy_current_state == 667);
  if (!yy_is_jam)
    *yy_state_ptr++ = yy_current_state;

  return yy_is_jam ? 0 : yy_current_state;
}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void
yyunput (int c, register char *yy_bp)
#else
static void
yyunput (c, yy_bp)
     int c;
     register char *yy_bp;
#endif
{
  register char *yy_cp = yy_c_buf_p;

  /* undo effects of setting up yytext */
  *yy_cp = yy_hold_char;

  if (yy_cp < yy_current_buffer->yy_ch_buf + 2)
    {				/* need to shift things up to make room */
      /* +2 for EOB chars. */
      register int number_to_move = yy_n_chars + 2;
      register char *dest =
	  &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size +
					2];
      register char *source =
	  &yy_current_buffer->yy_ch_buf[number_to_move];

      while (source > yy_current_buffer->yy_ch_buf)
	*--dest = *--source;

      yy_cp += (int) (dest - source);
      yy_bp += (int) (dest - source);
      yy_current_buffer->yy_n_chars =
	  yy_n_chars = yy_current_buffer->yy_buf_size;

      if (yy_cp < yy_current_buffer->yy_ch_buf + 2)
	YY_FATAL_ERROR ("flex scanner push-back overflow");
    }

  *--yy_cp = (char) c;


  yytext_ptr = yy_bp;
  yy_hold_char = *yy_cp;
  yy_c_buf_p = yy_cp;
}
#endif /* ifndef YY_NO_UNPUT */


#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int
yyinput ()
#else
static int
input ()
#endif
{
  int c;

  *yy_c_buf_p = yy_hold_char;

  if (*yy_c_buf_p == YY_END_OF_BUFFER_CHAR)
    {
      /* yy_c_buf_p now points to the character we want to return.
       * If this occurs *before* the EOB characters, then it's a
       * valid NUL; if not, then we've hit the end of the buffer.
       */
      if (yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars])
	/* This was really a NUL. */
	*yy_c_buf_p = '\0';

      else
	{			/* need more input */
	  int offset = yy_c_buf_p - yytext_ptr;
	  ++yy_c_buf_p;

	  switch (yy_get_next_buffer ())
	    {
	    case EOB_ACT_LAST_MATCH:
	      /* This happens because yy_g_n_b()
	       * sees that we've accumulated a
	       * token and flags that we need to
	       * try matching the token before
	       * proceeding.  But for input(),
	       * there's no matching to consider.
	       * So convert the EOB_ACT_LAST_MATCH
	       * to EOB_ACT_END_OF_FILE.
	       */

	      /* Reset buffer status. */
	      yyrestart (yyin);

	      /* fall through */

	    case EOB_ACT_END_OF_FILE:
	      {
		if (yywrap ())
		  return EOF;

		if (!yy_did_buffer_switch_on_eof)
		  YY_NEW_FILE;
#ifdef __cplusplus
		return yyinput ();
#else
		return input ();
#endif
	      }

	    case EOB_ACT_CONTINUE_SCAN:
	      yy_c_buf_p = yytext_ptr + offset;
	      break;
	    }
	}
    }

  c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
  *yy_c_buf_p = '\0';		/* preserve yytext */
  yy_hold_char = *++yy_c_buf_p;

  yy_current_buffer->yy_at_bol = (c == '\n');

  return c;
}
#endif /* YY_NO_INPUT */

#ifdef YY_USE_PROTOS
void
yyrestart (FILE * input_file)
#else
void
yyrestart (input_file)
     FILE *input_file;
#endif
{
  if (!yy_current_buffer)
    yy_current_buffer = yy_create_buffer (yyin, YY_BUF_SIZE);

  yy_init_buffer (yy_current_buffer, input_file);
  yy_load_buffer_state ();
}


#ifdef YY_USE_PROTOS
void
yy_switch_to_buffer (YY_BUFFER_STATE new_buffer)
#else
void
yy_switch_to_buffer (new_buffer)
     YY_BUFFER_STATE new_buffer;
#endif
{
  if (yy_current_buffer == new_buffer)
    return;

  if (yy_current_buffer)
    {
      /* Flush out information for old buffer. */
      *yy_c_buf_p = yy_hold_char;
      yy_current_buffer->yy_buf_pos = yy_c_buf_p;
      yy_current_buffer->yy_n_chars = yy_n_chars;
    }

  yy_current_buffer = new_buffer;
  yy_load_buffer_state ();

  /* We don't actually know whether we did this switch during
   * EOF (yywrap()) processing, but the only time this flag
   * is looked at is after yywrap() is called, so it's safe
   * to go ahead and always set it.
   */
  yy_did_buffer_switch_on_eof = 1;
}


#ifdef YY_USE_PROTOS
void
yy_load_buffer_state (void)
#else
void
yy_load_buffer_state ()
#endif
{
  yy_n_chars = yy_current_buffer->yy_n_chars;
  yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
  yyin = yy_current_buffer->yy_input_file;
  yy_hold_char = *yy_c_buf_p;
}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_create_buffer (FILE * file, int size)
#else
YY_BUFFER_STATE
yy_create_buffer (file, size)
     FILE *file;
     int size;
#endif
{
  YY_BUFFER_STATE b;

  b = (YY_BUFFER_STATE) yy_flex_alloc (sizeof (struct yy_buffer_state));
  if (!b)
    YY_FATAL_ERROR ("out of dynamic memory in yy_create_buffer()");

  b->yy_buf_size = size;

  /* yy_ch_buf has to be 2 characters longer than the size given because
   * we need to put in 2 end-of-buffer characters.
   */
  b->yy_ch_buf = (char *) yy_flex_alloc (b->yy_buf_size + 2);
  if (!b->yy_ch_buf)
    YY_FATAL_ERROR ("out of dynamic memory in yy_create_buffer()");

  b->yy_is_our_buffer = 1;

  yy_init_buffer (b, file);

  return b;
}


#ifdef YY_USE_PROTOS
void
yy_delete_buffer (YY_BUFFER_STATE b)
#else
void
yy_delete_buffer (b)
     YY_BUFFER_STATE b;
#endif
{
  if (!b)
    return;

  if (b == yy_current_buffer)
    yy_current_buffer = (YY_BUFFER_STATE) 0;

  if (b->yy_is_our_buffer)
    yy_flex_free ((void *) b->yy_ch_buf);

  yy_flex_free ((void *) b);
}



#ifdef YY_USE_PROTOS
void
yy_init_buffer (YY_BUFFER_STATE b, FILE * file)
#else
void
yy_init_buffer (b, file)
     YY_BUFFER_STATE b;
     FILE *file;
#endif


{
  yy_flush_buffer (b);

  b->yy_input_file = file;
  b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
  b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
  b->yy_is_interactive = 0;
#else
  b->yy_is_interactive = file ? (isatty (fileno (file)) > 0) : 0;
#endif
#endif
}


#ifdef YY_USE_PROTOS
void
yy_flush_buffer (YY_BUFFER_STATE b)
#else
void
yy_flush_buffer (b)
     YY_BUFFER_STATE b;
#endif

{
  if (!b)
    return;

  b->yy_n_chars = 0;

  /* We always need two end-of-buffer characters.  The first causes
   * a transition to the end-of-buffer state.  The second causes
   * a jam in that state.
   */
  b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
  b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

  b->yy_buf_pos = &b->yy_ch_buf[0];

  b->yy_at_bol = 1;
  b->yy_buffer_status = YY_BUFFER_NEW;

  if (b == yy_current_buffer)
    yy_load_buffer_state ();
}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_buffer (char *base, yy_size_t size)
#else
YY_BUFFER_STATE
yy_scan_buffer (base, size)
     char *base;
     yy_size_t size;
#endif
{
  YY_BUFFER_STATE b;

  if (size < 2 ||
      base[size - 2] != YY_END_OF_BUFFER_CHAR ||
      base[size - 1] != YY_END_OF_BUFFER_CHAR)
    /* They forgot to leave room for the EOB's. */
    return 0;

  b = (YY_BUFFER_STATE) yy_flex_alloc (sizeof (struct yy_buffer_state));
  if (!b)
    YY_FATAL_ERROR ("out of dynamic memory in yy_scan_buffer()");

  b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
  b->yy_buf_pos = b->yy_ch_buf = base;
  b->yy_is_our_buffer = 0;
  b->yy_input_file = 0;
  b->yy_n_chars = b->yy_buf_size;
  b->yy_is_interactive = 0;
  b->yy_at_bol = 1;
  b->yy_fill_buffer = 0;
  b->yy_buffer_status = YY_BUFFER_NEW;

  yy_switch_to_buffer (b);

  return b;
}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_string (yyconst char *yy_str)
#else
YY_BUFFER_STATE
yy_scan_string (yy_str)
     yyconst char *yy_str;
#endif
{
  int len;
  for (len = 0; yy_str[len]; ++len)
    ;

  return yy_scan_bytes (yy_str, len);
}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE
yy_scan_bytes (yyconst char *bytes, int len)
#else
YY_BUFFER_STATE
yy_scan_bytes (bytes, len)
     yyconst char *bytes;
     int len;
#endif
{
  YY_BUFFER_STATE b;
  char *buf;
  yy_size_t n;
  int i;

  /* Get memory for full buffer, including space for trailing EOB's. */
  n = len + 2;
  buf = (char *) yy_flex_alloc (n);
  if (!buf)
    YY_FATAL_ERROR ("out of dynamic memory in yy_scan_bytes()");

  for (i = 0; i < len; ++i)
    buf[i] = bytes[i];

  buf[len] = buf[len + 1] = YY_END_OF_BUFFER_CHAR;

  b = yy_scan_buffer (buf, n);
  if (!b)
    YY_FATAL_ERROR ("bad buffer in yy_scan_bytes()");

  /* It's okay to grow etc. this buffer, and we should throw it
   * away when we're done.
   */
  b->yy_is_our_buffer = 1;

  return b;
}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void
yy_push_state (int new_state)
#else
static void
yy_push_state (new_state)
     int new_state;
#endif
{
  if (yy_start_stack_ptr >= yy_start_stack_depth)
    {
      yy_size_t new_size;

      yy_start_stack_depth += YY_START_STACK_INCR;
      new_size = yy_start_stack_depth * sizeof (int);

      if (!yy_start_stack)
	yy_start_stack = (int *) yy_flex_alloc (new_size);

      else
	yy_start_stack = (int *) yy_flex_realloc ((void *) yy_start_stack,
						  new_size);

      if (!yy_start_stack)
	YY_FATAL_ERROR ("out of memory expanding start-condition stack");
    }

  yy_start_stack[yy_start_stack_ptr++] = YY_START;

  BEGIN (new_state);
}
#endif


#ifndef YY_NO_POP_STATE
static void
yy_pop_state ()
{
  if (--yy_start_stack_ptr < 0)
    YY_FATAL_ERROR ("start-condition stack underflow");

  BEGIN (yy_start_stack[yy_start_stack_ptr]);
}
#endif


#ifndef YY_NO_TOP_STATE
static int
yy_top_state ()
{
  return yy_start_stack[yy_start_stack_ptr - 1];
}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void
yy_fatal_error (yyconst char msg[])
#else
static void
yy_fatal_error (msg)
     char msg[];
#endif
{
  (void) fprintf (stderr, "%s\n", msg);
  exit (YY_EXIT_FAILURE);
}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void
yy_flex_strncpy (char *s1, yyconst char *s2, int n)
#else
static void
yy_flex_strncpy (s1, s2, n)
     char *s1;
     yyconst char *s2;
     int n;
#endif
{
  register int i;
  for (i = 0; i < n; ++i)
    s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int
yy_flex_strlen (yyconst char *s)
#else
static int
yy_flex_strlen (s)
     yyconst char *s;
#endif
{
  register int n;
  for (n = 0; s[n]; ++n)
    ;

  return n;
}
#endif


#ifdef YY_USE_PROTOS
static void *
yy_flex_alloc (yy_size_t size)
#else
static void *
yy_flex_alloc (size)
     yy_size_t size;
#endif
{
  return (void *) malloc (size);
}

#ifdef YY_USE_PROTOS
static void *
yy_flex_realloc (void *ptr, yy_size_t size)
#else
static void *
yy_flex_realloc (ptr, size)
     void *ptr;
     yy_size_t size;
#endif
{
  /* The cast to (char *) in the following accommodates both
   * implementations that use char* generic pointers, and those
   * that use void* generic pointers.  It works with the latter
   * because both ANSI C and C++ allow castless assignment from
   * any pointer type to void*, and deal with argument conversions
   * as though doing an assignment.
   */
  return (void *) realloc ((char *) ptr, size);
}

#ifdef YY_USE_PROTOS
static void
yy_flex_free (void *ptr)
#else
static void
yy_flex_free (ptr)
     void *ptr;
#endif
{
  free (ptr);
}

#if YY_MAIN
int
main ()
{
  yylex ();
  return 0;
}
#endif

void
yyerror (char *msg)
{
  int i, j;

  sprintf (string, "%s at %n", msg, &j);
  if (*yytext == '\n' || *yytext == '\0')
    {
      sprintf (string + j, "end of line");
    }
  else
    {
      i = 0;
      string[j++] = '\"';
      while (yytext[i])
	{
	  if (isprint (yytext[i]))
	    string[j++] = yytext[i++];
	  else
	    {
	      sprintf (string + j, "0x%02x", yytext[i]);
	      j += 4;
	      break;
	    }
	}
      string[j++] = '\"';
      string[j] = '\0';
    }
  error (ERROR, string);
  return;
}


void
open_main (FILE * file, char *explicit, char *main_file_name)	/* open main file */
{
  include_stack_ptr = 0;

  if (explicit)
    include_stack[include_stack_ptr] = yy_scan_string (explicit);
  else
    include_stack[include_stack_ptr] =
	yy_create_buffer (file, YY_BUF_SIZE);
  libfile_stack[include_stack_ptr] = new_file (main_file_name, "main");
  libfile_chain[libfile_chain_length++] = libfile_stack[include_stack_ptr];
  if (!explicit)
    yy_switch_to_buffer (include_stack[include_stack_ptr]);
  currlib = libfile_stack[0];
  inlib = FALSE;

  return;
}

void
open_string (char *cmd)		/* open string with commands */
{
  yy_switch_to_buffer (yy_scan_string (cmd));
}


int
import_lib (char *name)		/* import library */
{
  char *full;
  static int end_of_import = FALSE;

  if (!*name)
    name = pop (stSTRING)->pointer;
  while (isspace (*name))
    name++;

  if (!strcmp (name, "__END_OF_IMPORT"))
    end_of_import = TRUE;
  if (end_of_import)
    return TRUE;

  /* start line numbers anew */
  libfile_stack[include_stack_ptr]->lineno = yylineno;

  include_stack_ptr++;
  if (include_stack_ptr >= MAX_INCLUDE_DEPTH)
    {
      sprintf (string, "Could not import '%s': nested too deep", name);
      error (ERROR, string);
      return FALSE;
    }

  if (is_bound)
    {
      full = name;
    }
  else
    {
      yyin = open_library (name, &full, FALSE);
      if (!yyin)
	return FALSE;
      yy_switch_to_buffer (yy_create_buffer (yyin, YY_BUF_SIZE));
      include_stack[include_stack_ptr] = YY_CURRENT_BUFFER;
    }
  libfile_stack[include_stack_ptr] = new_file (full, NULL);
  libfile_chain[libfile_chain_length++] = libfile_stack[include_stack_ptr];
  if (libfile_chain_length >= MAX_INCLUDE_NUMBER)
    {
      sprintf (string, "Cannot import more than %d libraries",
	       MAX_INCLUDE_NUMBER);
      error (ERROR, string);
      return FALSE;
    }
  if (!libfile_stack[include_stack_ptr])
    {
      sprintf (string, "library '%s' has already been imported", full);
      error (ERROR, string);
      return FALSE;
    }

  if (infolevel >= NOTE && !is_bound)
    {
      sprintf (string, "importing from file '%s'", full);
      error (NOTE, string);
    }
  return TRUE;
}


FILE *
open_library (char *name, char **fullreturn, int without)	/* search and open a library */
{
  static char full[200];
  char unquoted[200];
  char *p;
  FILE *lib;
  int i;
  char *trail;

  if (fullreturn)
    *fullreturn = full;

  for (p = name; strchr (" \"'`", *p); p++)
    if (!*p)
      break;
  strncpy (unquoted, p, 200);
  for (; !strchr (" \"'`", *p); p++)
    if (!*p)
      break;
  if (*p)
    unquoted[p - name - 2] = '\0';
  name = unquoted;
  if (strchr (name, '.'))
    {
      sprintf (string, "library name '%s' contains '.'", name);
      error (ERROR, string);
      return NULL;
    }
  if (!strcmp (name, "main"))
    {
      if (is_bound)
	return NULL;
      error (ERROR, "invalid library name 'main'");
      return NULL;
    }

  /* search local */
  trail = ".yab";
  for (i = 0; i < 2; i++)
    {
      strcpy (full, name);
      if (!strchr (full, '.'))
	strcat (full, trail);
      lib = fopen (full, "r");
      if (lib)
	return lib;
      trail = "";
      if (!without)
	break;
    }

  /* search in global location */
  trail = ".yab";
  for (i = 0; i < 2; i++)
    {
      strcpy (full, library_path);
      if (full[0] && !strchr ("\\/", full[strlen (full) - 1]))
	{
#ifdef UNIX
	  strcat (full, "/");
#else
	  strcat (full, "\\");
#endif
	}
      strcat (full, name);
      if (!strchr (full, '.'))
	strcat (full, trail);
      lib = fopen (full, "r");
      if (lib)
	return lib;
      trail = "";
      if (!without)
	break;
    }

  sprintf (string, "couldn't open library '%s'", full);
  error (ERROR, string);
  return NULL;
}


void
switchlib (void)		/* switch library, called by bison */
{
  if (include_stack_ptr < 0)
    return;
  if (infolevel >= DEBUG)
    {
      sprintf (string, "switching from '%s' to '%s'", currlib->s,
	       libfile_stack[include_stack_ptr]->s);
      error (DEBUG, string);
    }
  currlib = libfile_stack[include_stack_ptr];
  yylineno = currlib->lineno;
  inlib = (include_stack_ptr > 0);
}
